#include <windows.h>


#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <math.h>
#include <stdio.h>

#include "BigNum.h"
#include "resource.h"

#define TEMPS_BONJOUR 1000
int ouverture_en_cours=1;
int fermeture_en_cours=0;
int last_ouverture=0;



/************************************************************************\
 *    FUNCTION: WinMain
\************************************************************************/

int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	MSG msg;

	if (lpCmdLine[0] == 47 ) //Verifie si la ligne de commande commence par le caractre "/"
	{
		switch(lpCmdLine[1]) 
		{
			case 'd': //le caractre = "d"
				if ( MessageBox(NULL,"Etes-vous sur de vouloir dsinstaller BigNums ?","BigNums",52) == 6 ) 
					Desinstall();					
				return (FALSE);
				break;
		}

	}


	#ifdef _SANSLICENCE
	VerifLicence(hInstance);
	#endif



	if (!hPrevInstance) {
		// Perform instance initialization:
		if (!InitApplication(hInstance)) {
			return (FALSE);
		}
	}

	// Perform application initialization:
	if (!InitInstance(hInstance, nCmdShow)) {
		return (FALSE);
	}


	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) {		
		TranslateMessage(&msg);
		DispatchMessage(&msg);		
	}

	return (msg.wParam);

	lpCmdLine; // This will prevent 'unused formal parameter' warnings
}



/************************************************************************\
 *    FUNCTION: InitApplication
\************************************************************************/


BOOL InitApplication(HINSTANCE hInstance)       /* current instance             */
{
  WNDCLASS wc;

      wc.lpszClassName = "BigNum"; //Nom de l'application
      wc.lpfnWndProc = WndProc; //Fonction de procdure principale
      wc.style = CS_DBLCLKS | CS_VREDRAW | CS_HREDRAW; //Style de fentre
      wc.hInstance = hInstance; //Instance de l'application
	  wc.hIcon = NULL;
      wc.hCursor = LoadCursor( NULL, IDC_ARROW ); //Curseur de la fentre, classique
      wc.hbrBackground = (HBRUSH)NULL; //Fond de la fentre, classique
      wc.lpszMenuName = NULL; //Nom du menu dans la ressource
      wc.cbClsExtra = 0; //NULL
      wc.cbWndExtra = 0; //NULL


 if (!RegisterClass( &wc )) return(FALSE);//Enregistre les configs
 return(TRUE);
}



/************************************************************************\
 *    FUNCTION: InitInstance
\************************************************************************/

BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	HWND hWnd;

	hInst = hInstance; // Store instance handle in our global variable


	hWnd = CreateWindowEx(0x00000180,"BigNum","Cartel Espace : Recherche & Dveloppement", 0x16c00000|WS_SYSMENU,
		0, -300, 0, 0,
		NULL, NULL, hInstance, NULL);

	if (!hWnd) {
		return (FALSE);
	}

	GetHandleCalculatrice();


	AutoSizeWindow(hWnd);

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	OuvertureAnim(hWnd);

	AfficherNBRTL(hWnd);

	if(option.info)
	{
		infoouvert = TRUE;
		ShowWindow(CreateDialog(hInst,MAKEINTRESOURCE(IDD_INFO),hWnd,(DLGPROC)Info),TRUE);
	}

	SetForegroundWindow(hWndCalc);

	last_ouverture=GetTickCount();
	ouverture_en_cours = 0;
	return (TRUE);
}


/************************************************************************\
 *    FUNCTION: WndProc
\************************************************************************/

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	int oldDlgTL;


	switch (message) { 

		case WM_CREATE:
			OnCreate(hWnd,(LPCREATESTRUCT) lParam); 
			break;

		case WM_HOTKEY:

			switch(wParam)
			{
			case HK_CTRL_M:
				OnFond(hWnd,1);
				break;
			case HK_CTRL_A:
				OnFond(hWnd,0);
				break;
			}
			break;

		case WM_COMMAND:
			wmId    = LOWORD(wParam); // Remember, these are...
			wmEvent = HIWORD(wParam); // ...different for Win32!

			// Deal with the menu selections:
			switch (wmId) 
			{
			case ID_TVA:
			case ID_POPUP_VALEURCONVERTIR_TTCHT:
			case ID_POPUP_VALEURCONVERTIR_HTTTC:
				SetTTC(hWnd,wmId);
				break;

			case ID_AUCUN:
			case ID_FRANC:
			case ID_EURO:
			case ID_DOLLAR:
			case ID_AUTRE:
			case ID_CONVFRANC:
			case ID_CONVEURO:
			case ID_CONVDOLLAR:
			case ID_CONVAUTRE:
			case ID_POPUP_SYMBOLE_MONNAITAIRE:
			case ID_POPUP_SYMBOLE_POIDSETMESURES:
			case ID_CONVMONNAIE:
			case ID_POPUP_POIDSETMESURES_KILOGRAMME :
			case ID_POPUP_POIDSETMESURES_TONNE   :
			case ID_POPUP_POIDSETMESURES_LITTRE  :
			case ID_POPUP_POIDSETMESURES_MTRE    :
			case ID_POPUP_POIDSETMESURES_KILOMTRE :
			case ID_POPUP_POIDSETMESURES_POUCE   :
			case ID_POPUP_POIDSETMESURES_CENTIMTRE :
			case ID_POPUP_POIDSETMESURES_AUTRE   :
			case ID_CONVCM:
			case ID_CONVERTISSEURFRANCEURO:	
			case ID_CONVERTISSEUREUROFRANC:
			case ID_CONVERTISSEURDOLLAREURO:
			case ID_CONVERTISSEUREURODOLLAR:
			case ID_CONVERTISSEURAUTREEURO:
			case ID_CONVERTISSEUREUROAUTRE:
				SetSyboleMonaitaire(hWnd,wmId);
				break;


			case ID_POPUP_POIDSETMESURES_AUCUN:
				SetSyboleMonaitaire(hWnd,ID_AUCUN);
				break;

			case ID_TOUJOURSVISIBLE:
				option.toujoursvisible = option.toujoursvisible ? FALSE : TRUE;
				SetTopMost(hWnd);
				break;

			case ID_NBRTL:
				option.DlgTL = option.DlgTL ? FALSE : TRUE;
				AfficherNBRTL(hWnd);
				break;

			case ID_POPUP_OUVRIRLESOPTIONSSUR_AFFICHAGE :
			case ID_POPUP_OUVRIRLESOPTIONSSUR_MONNAIEPOIDSETETMESURES :
			case ID_POPUP_OUVRIRLESOPTIONSSUR_APROPOSDE :
			case ID_POPUP_OUVRIRLESOPTIONSSUR_TLCOMMANDE :
			case ID_POPUP_OUVRIRLESOPTIONSSUR_PROGRAMMEUR :
				OnFond(hWnd,wmId-40028);
				break;

			}
			break;


		case WM_PAINT:
			hdc = BeginPaint (hWnd, &ps);

			OnPaint(hWnd,ps.hdc);

			EndPaint (hWnd, &ps);
			break;   
			
		case WM_ACTIVATE:
		case WM_LBUTTONDOWN:
		case WM_NCLBUTTONDOWN:
			SetForegroundWindow(hWndCalc);
			break;   
		
		case WM_TIMER:
			OnTimer(hWnd,wParam);
			break;

		case WM_RBUTTONUP:
			AfficherMenuPop(hWnd);
			//OnFond(hWnd,0);
			break;

		case WM_MBUTTONUP:
			//AfficherMenuPop(hWnd);
			OnFond(hWnd,0);
			break;

		case WM_CLOSE:
			//fermeture_en_cours=1;

			fermeture_en_cours=1;
			InvalidateRect(hWnd,NULL,TRUE);
			UpdateWindow(hWnd);
			Sleep(500);


			oldDlgTL = option.DlgTL;
			PostMessage(hnbrtl,WM_CLOSE,0,0);	
			if(option.anim)FermetureAnim(hWnd);
			DestroyWindow(hWnd);
			option.DlgTL = oldDlgTL;
			break;

		case WM_DESTROY:
			SavePref(hWnd);
			RemetVerrNum();
			DeleteObject(hBitmapFond);
			DeleteObject(hBitmapFondNbrTl);
			KillTimer(hWnd,1);
			PostMessage(hWndCalc,WM_CLOSE,0,0);
			PostQuitMessage(0);
			break;

		default:
			return (DefWindowProc(hWnd, message, wParam, lParam));
	}
	return (0);
}

void OnCreate(HWND hWnd,LPCREATESTRUCT lpcs)
{
	int a=0;

	ancientext[0]=0;
	dejafg = 0;
	hnbrtl = NULL;

	ShellExecute(NULL,"open","calc.exe","","",SW_SHOW);

	while((hWndCalc==0)&&(a<100))
	{	
		a++;
		GetHandleCalculatrice();
		Sleep(100);
		SendMessage(hWndCalcStatic,WM_GETTEXT,255,(LPARAM)ancientext_calc);
	}

	CenterWindow(hWndCalc,GetDesktopWindow());

	infoouvert = FALSE;	
	SetTimer(hWnd,1,1,NULL);
	Instal(hWnd);
	LoadPref(hWnd);
	AutoSizeWindow(hWnd);
	SetTopMost(hWnd);
	ActiveVerrNum();
	RegisterHotKey(hWnd,HK_CTRL_M,MOD_CONTROL,'M');
	RegisterHotKey(hWnd,HK_CTRL_A,MOD_CONTROL,'A');
}

void GetHandleCalculatrice()
{
	char text[255];
	HWND hWndTemp;
	LONG style;
	int a=0;

	hWndCalc = FindWindowEx(NULL,NULL,"SciCalc",NULL);

	if(!hWndCalc) 
		return;

	hWndTemp = NULL;


	while(a<100)
	{
		a++;
		hWndTemp = FindWindowEx(hWndCalc,hWndTemp,"Static",NULL);
		if(hWndTemp==NULL) break;
		GetWindowText(hWndTemp,text,255);
		if((text[0]!=0))
			if((text[1]!='M'))
				if((text[0]!='M'))
					if((text[0]!='('))
					{
						style = GetWindowLong(hWndTemp,GWL_STYLE);
						if(style & WS_VISIBLE)
							break;
					}
	}

	if((hWndTemp==0)||(text[0]==0)) hWndTemp = FindWindowEx(hWndCalc,NULL,"Edit",NULL);

	SendMessage(hWndTemp,WM_GETTEXT,255,(LPARAM)text);

	hWndCalcStatic = hWndTemp;
}

void DrawAurevoir(HDC hdc,LPRECT rc){

	

}

void OnPaint(HWND hWnd,HDC hdc2)
{
	RECT rectarea,recttext,recttext2;
	char text[255]="";
	char valeur1[255]="";
	char valeur2[255]="";

	double nombre1,nombre2=0;

	HBRUSH hBrushFond;
	HFONT font,oldFont;
	HBITMAP hbitmap,hbitmapOld;
	HDC hdc;
	double valeur;
	int a;
	int len;
	int align=DT_LEFT;
	int fin=0;


	GetClientRect(hWnd,&rectarea);

	SendMessage(hWndCalcStatic,WM_GETTEXT,255,(LPARAM)text);

	if(/*!IsWindow(hWndCalcStatic) || */fermeture_en_cours){
		strcpy(text,"Merci et  bientt");
		align=DT_CENTER|DT_VCENTER;
		fin=1;
	}

	if( (strcmp(ancientext_calc,text)==0) && ( ouverture_en_cours || ((GetTickCount()-last_ouverture)<TEMPS_BONJOUR)))
	{	
		strcpy(ancientext_calc,text);
		//if(strcmp(ancientext,text)!=0) last_ouverture = 0;
		strcpy(text,"Bonjour");
		align=DT_CENTER|DT_VCENTER;
		fin=1;
	}

	strcpy(ancientext,text);


	if(!fin){
	AjouterPoint(text,option.symbole);

	if(option.activerconverttva) AjouterTVA(text,option.nonconverttva);

	}

	hdc = CreateCompatibleDC(hdc2);
	hbitmap = CreateCompatibleBitmap (hdc2, rectarea.right - rectarea.left, rectarea.bottom - rectarea.top);
	hbitmapOld = (HBITMAP)SelectObject (hdc, hbitmap);


	switch(option.colorfondtype)
	{
	case 0:
		hBrushFond = CreateSolidBrush(option.colorfondsimple);

		FillRect(hdc,&rectarea,hBrushFond);

		DeleteObject(hBrushFond);
		break;
	case 1:
		DrawDegrade(hdc, option.colorfonddepart, option.colorfondarrive,0, 0, &rectarea);

		break;
	case 2:
		DrawBitmap (hdc,&rectarea, hBitmapFond, FALSE);
		break;
	}


	hBrushFond = CreateSolidBrush(option.colorfont);

	FrameRect(hdc,&rectarea,hBrushFond);

	DeleteObject(hBrushFond);

	recttext = rectarea;
	recttext.left++;
	recttext.top++;
	recttext.right--;
	recttext.bottom--;
	if((((((option.convertiseuractiver)&&((option.symbole>0)&&(option.symbole<5)))||((option.convertiseursymbolemesure) && ((option.symbole==10)||(option.symbole==11)))))||option.activerconverttva)&&(!fin))recttext.bottom /=2;

	recttext2.left=recttext.left;
	recttext2.top=recttext.bottom;
	recttext2.right=recttext.right;
	recttext2.bottom=rectarea.bottom;

	SetTextColor(hdc,option.colorfont); 
	SetBkMode(hdc,TRANSPARENT) ;               //transparent text


	font = CreateFontIndirect(&option.font);
	oldFont = SelectObject(hdc,font);


	DrawText(hdc,text,strlen(text),&recttext,DT_SINGLELINE|DT_VCENTER|align);
	strcpy(valeur1,text);

	SelectObject(hdc,oldFont);
	DeleteObject(font);

	strcpy(text,ancientext);

	len = strlen(text);
	for(a=0;a<len;a++){if(text[a]==',')text[a]='.';}

	nombre1 = valeur = atof(text);

	if((((((option.convertiseuractiver)&&((option.symbole>0)&&(option.symbole<5)))||((option.convertiseursymbolemesure) && ((option.symbole==10)||(option.symbole==11)))))||option.activerconverttva)&&(!fin))
	{


		//if(option.symbole == 0) 

		if(option.activerconverttva) if(option.converttva != option.nonconverttva) if(option.converttva) valeur=ConvertTTC(valeur); else valeur=ConvertHT(valeur);

		if((option.convertiseursymbolemesure)&&((option.symbole==10)||(option.symbole==11)))
		{
			if(option.symbole==10)
			{
				nombre2 = ConvertirMonnaie(valeur,option.symbole,11);
			}
			if(option.symbole==11)
			{
				nombre2 = ConvertirMonnaie(valeur,option.symbole,10);
			}
		}
		else
		{
			if(option.symbole!=0)
			{
				nombre2 = ConvertirMonnaie(valeur,option.symbole,(option.convertiseuractiver?option.convertiseursymbole+1:option.symbole)); 
			}
			else 
			{
				nombre2 = valeur;
			}
		}

		sprintf(text,"%f",nombre2);

		len = strlen(text);
		for(a=0;a<len;a++){if(text[a]=='.')text[a]=',';}

		len = strlen(text);
		for(a=len-1;a>0;a--){
			if(text[a]=='0')text[a]=0;else break;}
		
		if((option.convertiseursymbolemesure)&&((option.symbole==10)||(option.symbole==11)))
		{
			if(option.symbole==10)
				AjouterPoint(text,11);
			if(option.symbole==11)
				AjouterPoint(text,10);
		}
		else
		{
			AjouterPoint(text,((option.convertiseuractiver&&((option.symbole > 0)&&(option.symbole <= 4)))?option.convertiseursymbole+1:option.symbole));
		}
		

		if(option.activerconverttva) AjouterTVA(text,option.converttva);

		SetTextColor(hdc,option.colorfontconv); 

		font = CreateFontIndirect(&option.fontconv);
		oldFont = SelectObject(hdc,font);

		DrawText(hdc,text,strlen(text),&recttext2,DT_SINGLELINE|DT_VCENTER|DT_LEFT);
		strcpy(valeur2,text);

		SelectObject(hdc,oldFont);
		DeleteObject(font);
	}

	AfficheTouteLettre(nombre1,nombre2,valeur1,valeur2);

	BitBlt(hdc2, rectarea.left, rectarea.top ,rectarea.right - rectarea.left, rectarea.bottom - rectarea.top ,hdc, 0, 0, SRCCOPY); 
 
	SelectObject (hdc, hbitmapOld);
	DeleteObject (hbitmap);

	DeleteDC(hdc); 
}

void OnTimer(HWND hWnd,int wID)
{
	char text[255];
	int style;
	BOOL calcfg;

	style = GetWindowLong(hWnd,GWL_STYLE);

	GetHandleCalculatrice();

	if(!hWndCalc){
		/*fermeture_en_cours=1;
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		Sleep(500);*/
		PostMessage(hWnd,WM_CLOSE,0,0);
		return;
	}

	if(IsIconic(hWndCalc))
	{
		if((style & WS_VISIBLE))
		{
			SetWindowPos(hWnd,NULL,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE|SWP_HIDEWINDOW);
			SetWindowPos(hnbrtl,NULL,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE|SWP_HIDEWINDOW);
		}
	}
	else
	{
		if(!(style & WS_VISIBLE))
		{
			SetWindowPos(hWnd,NULL,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE|SWP_SHOWWINDOW);
			SetWindowPos(hnbrtl,NULL,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE|SWP_SHOWWINDOW);
		}
	}

	calcfg = (GetForegroundWindow() == hWndCalc);

	if(!calcfg)
		dejafg = 0;


	if((!dejafg)&&calcfg)
	{

		SetForegroundWindow(hWnd);
		dejafg=1;

	}

	//GetWindowText(hWndCalcStatic,text,255);
	SendMessage(hWndCalcStatic,WM_GETTEXT,255,(LPARAM)text);
	
	if((strcmp(ancientext,text)) != 0 )
	{
		if(option.jouerson && (!infoouvert) && !((GetTickCount()-last_ouverture)<TEMPS_BONJOUR))
		{
			PlaySound(option.pathson,NULL,SND_ASYNC  | SND_FILENAME );
			SetForegroundWindow(hWnd);
		}
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
	}


}

void SetTextMenu(HMENU hMenu,int wmId,char* titre,int size)
{

	MENUITEMINFO menuinfo;

	ZeroMemory(&menuinfo,sizeof(MENUITEMINFO));

	menuinfo.cbSize = sizeof(MENUITEMINFO);
	menuinfo.fMask = MIIM_TYPE;
	menuinfo.fType = MFT_STRING;
	menuinfo.dwTypeData = titre;
	menuinfo.cch = size;

	SetMenuItemInfo(hMenu,wmId,FALSE,&menuinfo);

}

void AfficherMenuPop(HWND hWnd)
{
	HMENU hMenu;
	HMENU hMenuTrackPopup;
	POINT pt;
	char text[255];

	//Charge le menu
	hMenu = LoadMenu(hInst, MAKEINTRESOURCE(IDR_MENUPOPUP));

	hMenuTrackPopup = GetSubMenu(hMenu, 0);

	if (option.toujoursvisible) CheckMenuItem(hMenuTrackPopup,ID_TOUJOURSVISIBLE,MF_CHECKED|MF_BYCOMMAND); else CheckMenuItem(hMenuTrackPopup,ID_TOUJOURSVISIBLE,MF_UNCHECKED|MF_BYCOMMAND);			
	if (option.activerconverttva) CheckMenuItem(hMenuTrackPopup,ID_TVA,MF_CHECKED|MF_BYCOMMAND); else CheckMenuItem(hMenuTrackPopup,ID_TVA,MF_UNCHECKED|MF_BYCOMMAND);			
	if (option.convertiseuractiver) CheckMenuItem(hMenuTrackPopup,ID_CONVMONNAIE,MF_CHECKED|MF_BYCOMMAND); else CheckMenuItem(hMenuTrackPopup,ID_CONVMONNAIE,MF_UNCHECKED|MF_BYCOMMAND);			
	if (option.convertiseursymbolemesure) CheckMenuItem(hMenuTrackPopup,ID_CONVCM,MF_CHECKED|MF_BYCOMMAND); else CheckMenuItem(hMenuTrackPopup,ID_CONVCM,MF_UNCHECKED|MF_BYCOMMAND);			
	if (option.DlgTL) CheckMenuItem(hMenuTrackPopup,ID_NBRTL,MF_CHECKED|MF_BYCOMMAND); else CheckMenuItem(hMenuTrackPopup,ID_NBRTL,MF_UNCHECKED|MF_BYCOMMAND);			

	
	
	
	if(option.nonconverttva && (!option.converttva)) CheckMenuRadioItem(hMenuTrackPopup,ID_POPUP_VALEURCONVERTIR_TTCHT,ID_POPUP_VALEURCONVERTIR_HTTTC,ID_POPUP_VALEURCONVERTIR_TTCHT,MF_BYCOMMAND);
	if((!option.nonconverttva) && option.converttva) CheckMenuRadioItem(hMenuTrackPopup,ID_POPUP_VALEURCONVERTIR_TTCHT,ID_POPUP_VALEURCONVERTIR_HTTTC,ID_POPUP_VALEURCONVERTIR_HTTTC,MF_BYCOMMAND);

	CheckMenuRadioItem(hMenuTrackPopup,ID_POPUP_SYMBOLE_MONNAITAIRE,ID_POPUP_SYMBOLE_POIDSETMESURES,ID_POPUP_SYMBOLE_MONNAITAIRE+(option.symbole>4),MF_BYCOMMAND);

	CheckMenuRadioItem(hMenuTrackPopup,ID_AUCUN,ID_AUTRE,ID_AUCUN+option.symbole,MF_BYCOMMAND);
	CheckMenuRadioItem(hMenuTrackPopup,ID_POPUP_POIDSETMESURES_AUCUN,ID_POPUP_POIDSETMESURES_AUTRE,ID_POPUP_POIDSETMESURES_AUCUN+option.symbole-4,MF_BYCOMMAND);
	CheckMenuRadioItem(hMenuTrackPopup,ID_CONVFRANC,ID_CONVAUTRE,ID_CONVFRANC+option.convertiseursymbole,MF_BYCOMMAND);


	if(!((option.symbole<5)&&(option.symbole!=0)))EnableMenuItem(hMenuTrackPopup,ID_CONVMONNAIE,MF_BYCOMMAND|MF_GRAYED);
	if(!((option.symbole>4)&&(option.symbole==10||option.symbole==11)))EnableMenuItem(hMenuTrackPopup,ID_CONVCM,MF_BYCOMMAND|MF_GRAYED);

	if(!(option.symbole<5))EnableMenuItem(hMenuTrackPopup,16,MF_BYPOSITION|MF_GRAYED);
	if(!(option.symbole>4))EnableMenuItem(hMenuTrackPopup,18,MF_BYPOSITION|MF_GRAYED);
	if(!(option.convertiseuractiver&&(option.symbole<5)&&(option.symbole!=0)))EnableMenuItem(hMenuTrackPopup,21,MF_BYPOSITION|MF_GRAYED);

	if(!option.activerconverttva)EnableMenuItem(hMenuTrackPopup,10,MF_BYPOSITION|MF_GRAYED);


	wsprintf(text,"Convertisseur Euro/%s",option.autremonnaie);
	SetTextMenu(hMenuTrackPopup,ID_CONVERTISSEUREUROAUTRE,text,255);

	wsprintf(text,"Convertisseur %s/Euro",option.autremonnaie);
	SetTextMenu(hMenuTrackPopup,ID_CONVERTISSEURAUTREEURO,text,255);

	GetCursorPos(&pt);
	
	//Affiche le menu
	TrackPopupMenu(hMenuTrackPopup,(UINT)NULL,
		pt.x,  pt.y, 0, hWnd, NULL);

	//Dtruit le menu
	DestroyMenu(hMenu);

}

void OnPolice(HWND hWnd)
{
		AutoSizeWindow(hWnd);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
}

void FillInPropertyPage( PROPSHEETPAGE* psp, int idDlg, LPSTR pszProc, DLGPROC pfnDlgProc, int icon)
{
    psp->dwSize = sizeof(PROPSHEETPAGE);
    psp->dwFlags = PSP_USEICONID | PSP_USETITLE ;
    psp->hInstance = hInst;
    psp->pszTemplate = MAKEINTRESOURCE(idDlg);
    psp->pszIcon = MAKEINTRESOURCE(icon);
    psp->pfnDlgProc = pfnDlgProc;
    psp->pszTitle = pszProc;
    psp->lParam = 0;
}

int CALLBACK PropSheetProc( HWND hwndDlg, UINT uMsg, LPARAM lParam)
{

	//if(uMsg==PSCB_INITIALIZED)
	return (TRUE);

}
 

void OnFond(HWND hWnd,int StartPage)
{

    PROPSHEETPAGE psp[5];
    PROPSHEETHEADER psh;

	FillInPropertyPage( &psp[0], IDD_FOND, "Affichage", (DLGPROC)Fond, 0);
	FillInPropertyPage( &psp[1], IDD_MONNAIE, "Monnaie,Poids et mesures", (DLGPROC)Monnaie, 0);
	FillInPropertyPage( &psp[2], IDD_ABOUT, "A propos de", (DLGPROC)About, 0);
	FillInPropertyPage( &psp[3], IDD_TELECOMMANDE, "Tlcommande", (DLGPROC)Telecommande, 0);
	FillInPropertyPage( &psp[4], IDD_PROGRAMMEUR, "Programmeur", (DLGPROC)Programmeur, 0);


    psh.dwSize = sizeof(PROPSHEETHEADER);
    psh.dwFlags = PSH_PROPSHEETPAGE|PSH_USECALLBACK|PSH_NOAPPLYNOW;
    psh.hwndParent = hWnd;
    psh.pszCaption = "Options";
    psh.nPages = sizeof(psp) / sizeof(PROPSHEETPAGE);
    psh.ppsp = (LPCPROPSHEETPAGE) &psp;
	psh.pfnCallback = (PFNPROPSHEETCALLBACK)PropSheetProc;
	psh.hInstance = hInst;
    psh.nStartPage = StartPage;
    psh.pszIcon = NULL;

	dejacenter = FALSE;

	MonnaieCree = FALSE;
	FondCree = FALSE;

	if(PropertySheet(&psh))
	{
		if(FondCree) OnOKFond();
		if(MonnaieCree) OnOKMonnaie();
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		AutoSizeWindow(hWnd);
		SetTopMost(hWnd);
		SavePref(hWnd);
		SetForegroundWindow(hWndCalc);
	}
}

void SetTopMost(HWND hWnd)
{
	HWND hWndInsertAfter;

	hWndInsertAfter=option.toujoursvisible ? HWND_TOPMOST : HWND_NOTOPMOST;

	SetWindowPos(hWnd,hWndInsertAfter,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE|SWP_NOACTIVATE);
	SetWindowPos(hWndCalc,hWndInsertAfter,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE|SWP_NOACTIVATE);
}


void DrawBitmap (HDC hdc,RECT *SizeImage, HBITMAP hbm, BOOL Circle)
{
    BOOL f; //rsultat de StretchBlt
    HDC hdcBits; // Handle du Compatible DC 
    BITMAP bm; // Handle du Bitamp
	HRGN rgn; //Rgion du cercle d'affichage

	//Cre un compatible DC
    hdcBits = CreateCompatibleDC(hdc);
	//hdcBits = hdc;

	//Slctionne le BITMAP
    GetObject (hbm, sizeof(BITMAP), &bm);
    SelectObject(hdcBits,hbm);

	//Si SizeImage->right = -1 alors l'image sera  sa taille d'origine
	if (SizeImage->right == -1) SizeImage->right = bm.bmWidth;
	if (SizeImage->bottom == -1) SizeImage->bottom = bm.bmHeight;

	//Cre le cercle de la rgion 
	rgn = CreateEllipticRgn(SizeImage->left,
		SizeImage->top,
		SizeImage->right,
		SizeImage->bottom );

	//Si Circle est vrai alors selection de la rgion
	if (Circle) SelectClipRgn(hdc,rgn);

	//Affiche le BITMAP
    f = StretchBlt(
		hdc,
		SizeImage->left,
		SizeImage->top,
		SizeImage->right - SizeImage->left,
		SizeImage->bottom - SizeImage->top,
		hdcBits,
		0,
		0,
		bm.bmWidth, 
		bm.bmHeight,
		SRCCOPY
		);

	//Supprime les objets
	SelectClipRgn(hdc,NULL);
    DeleteDC(hdcBits);
	DeleteObject(rgn);
}

void DrawDegrade(HDC hdc, COLORREF CouleurDepart, COLORREF CouleurArrive,int Type, int Variente, LPRECT area)
{
	double divR; // Raport couleur/taille de la couleur rouge
	double divG; // Raport couleur/taille de la couleur verte
	double divB; // Raport couleur/taille de la couleur bleu
	double couleurR; //Couleur Rouge
	double couleurG; //Couleur Verte
	double couleurB; //Couleur Bleu
	double bottom; //y conner du ractancle
	double right; //x conner du ractancle
	HPEN hPen; //Handle du crayon
	HPEN oldPen; //Handle du crayon
	HBRUSH hBrush; //Handle de la brose
	HBRUSH oldBrush; //Handle de la brose
	double Rd; //Rouge de la couleur de dpart
	double Gd; //Vert de la couleur de dpart
	double Bd; //Bleu de la couleur de dpart
	int a; //Boucle
	double NbrT;


	couleurR = GetRValue (CouleurDepart);
	couleurG = GetGValue (CouleurDepart);
	couleurB = GetBValue (CouleurDepart);

	bottom = (float)area->bottom;
	right = (float)area->right;

	Rd = GetRValue (CouleurArrive) - couleurR;
	Gd = GetGValue (CouleurArrive) - couleurG;
	Bd = GetBValue (CouleurArrive) - couleurB;

	switch (Type) 
	{
		case 0:

			divR = 2 * Rd / bottom ;
			divG = 2 * Gd / bottom ;
			divB = 2 * Bd / bottom ;

			for (a = area->top + 1; a <= bottom - 1; a += 2)
			{

				hPen = CreatePen(PS_NULL ,1,RGB(couleurR,couleurG,couleurB));
				hBrush = CreateSolidBrush(RGB(couleurR,couleurG,couleurB));
				oldBrush = SelectObject(hdc,hBrush);
				oldPen = SelectObject(hdc,hPen);

				Rectangle(hdc,area->left,a - 1,area->right,a + 2);

				couleurR += divR; 
				couleurG += divG; 
				couleurB += divB; 

				SelectObject(hdc,oldPen);
				DeleteObject(hPen);
				SelectObject(hdc,oldBrush);
				DeleteObject(hBrush);

			}	

			break;

		case 1:

			divR = 2 * Rd / right ;
			divG = 2 * Gd / right ;
			divB = 2 * Bd / right ;

			for (a = area->left + 1; a <= right - 1; a += 2)
			{

				hPen = CreatePen(PS_NULL ,1,RGB(couleurR,couleurG,couleurB));
				hBrush = CreateSolidBrush(RGB(couleurR,couleurG,couleurB));
				oldBrush = SelectObject(hdc,hBrush);
				oldPen = SelectObject(hdc,hPen);


				Rectangle(hdc,a - 1,area->top,a + 2,area->bottom);

				couleurR += divR; 
				couleurG += divG; 
				couleurB += divB; 

				SelectObject(hdc,oldPen);
				DeleteObject(hPen);
				SelectObject(hdc,oldBrush);
				DeleteObject(hBrush);

			}

			break;
	
		case 2:

			NbrT = sqrt(2) * sqrt((bottom * bottom) + (right  * right ));

			for (a=1;a <= NbrT;a++)
			{
				couleurR += (Rd / NbrT); 
				couleurG += (Gd / NbrT); 
				couleurB += (Bd / NbrT); 

				hPen = CreatePen(PS_SOLID ,1,RGB(couleurR,couleurG,couleurB));
				oldPen = SelectObject(hdc,hPen);
				MoveToEx(hdc,a,area->top,NULL);
				LineTo(hdc,area->left  ,a);
				SelectObject(hdc,oldPen);
				DeleteObject(hPen);

			}
			break;

		case 3:

			NbrT = sqrt(2) * sqrt((bottom  * bottom ) + (right * right));

			for (a=1;a <= NbrT;a++)
			{
				couleurR += (Rd / NbrT); 
				couleurG += (Gd / NbrT); 
				couleurB += (Bd / NbrT); 

				hPen = CreatePen(PS_SOLID ,1,RGB(couleurR,couleurG,couleurB));
				oldPen = SelectObject(hdc,hPen);
				MoveToEx(hdc,area->right - a,area->top,NULL);
				LineTo(hdc,area->right ,a);
				SelectObject(hdc,oldPen);
				DeleteObject(hPen);
			}

			break;
	}


}


void AutoSizeWindow(HWND hWnd)
{
	int largeurecran;
	int hauteurecran;
	SIZE size;
	HFONT font,oldFont;
	RECT rect,rectarea;
	HDC hdc;
	RECT rect2;

	GetWindowRect(hWnd,&rect2);

	largeurecran = GetSystemMetrics(SM_CXSCREEN);
	hauteurecran = GetSystemMetrics(SM_CYSCREEN);

	hdc = GetDC(hWnd);
	font = CreateFontIndirect(&option.font);
	oldFont = SelectObject(hdc,font);
	GetTextExtentPoint32(hdc,"0,23456789",10,&size);
	SelectObject(hdc,oldFont);
	DeleteObject(font);
	ReleaseDC(hWnd,hdc);

	GetWindowRect(hWnd,&rect);

	GetClientRect(hWnd,&rectarea);

	if(((((option.convertiseuractiver)&&((option.symbole>0)&&(option.symbole<5)))||((option.convertiseursymbolemesure) && ((option.symbole==10)||(option.symbole==11)))))||option.activerconverttva) size.cy *= 2;


	MoveWindow(hWnd,rect2.left,rect2.top,largeurecran,size.cy+20+(rect.bottom-rect.top-rectarea.bottom),TRUE);

	SetForegroundWindow(hWndCalc);

}

void ActiveVerrNum()
{
	BYTE keys[256];
	GetKeyboardState((LPBYTE)&keys);
	remetrevernum = !keys[VK_NUMLOCK];
	keys[VK_NUMLOCK] = 1;
	SetKeyboardState((LPBYTE)&keys);

}

void RemetVerrNum()
{
	BYTE keys[256];

	if(remetrevernum)
	{
		GetKeyboardState((LPBYTE)&keys);
		keys[VK_NUMLOCK] = 0;
		SetKeyboardState((LPBYTE)&keys);
	}
}

void SetSyboleMonaitaire(HWND hWnd,UINT wID)
{
	if((wID>=ID_AUCUN)&&(wID<=ID_AUTRE)) 
		option.symbole = wID-ID_AUCUN;

	if((wID>=ID_POPUP_POIDSETMESURES_KILOGRAMME)&&(wID<=ID_POPUP_POIDSETMESURES_AUTRE)) 
		option.symbole = (wID-ID_POPUP_POIDSETMESURES_KILOGRAMME)+5;

	if((wID>=ID_CONVFRANC)&&(wID<=ID_CONVAUTRE)) 
		option.convertiseursymbole = wID-ID_CONVFRANC;

	switch(wID)
	{	

	case ID_CONVERTISSEURFRANCEURO:
			option.symbole =1;
			option.convertiseursymbole = 1;
			option.convertiseuractiver=TRUE;
			break;

	case ID_CONVERTISSEUREUROFRANC:
			option.symbole =2;
			option.convertiseursymbole = 0;
			option.convertiseuractiver=TRUE;
			break;

	case ID_CONVERTISSEUREURODOLLAR:
			option.symbole =2;
			option.convertiseursymbole = 2;
			option.convertiseuractiver=TRUE;
			break;

	case ID_CONVERTISSEURDOLLAREURO:
			option.symbole =3;
			option.convertiseursymbole = 1;
			option.convertiseuractiver=TRUE;
			break;

	case ID_CONVERTISSEUREUROAUTRE:
			option.symbole =2;
			option.convertiseursymbole = 3;
			option.convertiseuractiver=TRUE;
			break;

	case ID_CONVERTISSEURAUTREEURO:
			option.symbole =4;
			option.convertiseursymbole = 1;
			option.convertiseuractiver=TRUE;
			break;

	case ID_POPUP_SYMBOLE_POIDSETMESURES:
		option.symbole=5;
		break;

	case ID_POPUP_SYMBOLE_MONNAITAIRE:
		option.symbole=0;
		break;

	case ID_CONVMONNAIE:
		option.convertiseuractiver = option.convertiseuractiver ? FALSE : TRUE;
		break;

	case ID_CONVCM:
		option.convertiseursymbolemesure = option.convertiseursymbolemesure ? FALSE : TRUE;
		break;

	}
	InvalidateRect(hWnd,NULL,TRUE);
	UpdateWindow(hWnd);
	AutoSizeWindow(hWnd);
}

void SetTTC(HWND hWnd,UINT wID)
{
	switch(wID)
	{
	case ID_TVA:
		option.activerconverttva = option.activerconverttva ? FALSE : TRUE;
		AutoSizeWindow(hWnd);
		break;
	case ID_POPUP_VALEURCONVERTIR_TTCHT:
		option.nonconverttva=1;
		option.converttva=0;
		break;
	case ID_POPUP_VALEURCONVERTIR_HTTTC:
		option.nonconverttva=0;
		option.converttva=1;
		break;

	}



	InvalidateRect(hWnd,NULL,TRUE);
	UpdateWindow(hWnd);
}


BOOL CenterWindow (HWND hwndChild, HWND hwndParent)
{
	RECT    rChild, rParent, rWorkArea = {0,0,0,0};
	int     wChild, hChild, wParent, hParent;
	int     xNew, yNew;
	BOOL	bResult;

	// Get the Height and Width of the child window
	GetWindowRect (hwndChild, &rChild);
	wChild = rChild.right - rChild.left;
	hChild = rChild.bottom - rChild.top;

	// Get the Height and Width of the parent window
	GetWindowRect (hwndParent, &rParent);
	wParent = rParent.right - rParent.left;
	hParent = rParent.bottom - rParent.top;

	// Get the limits of the 'workarea'
	bResult = SystemParametersInfo( SPI_GETWORKAREA, sizeof(RECT), &rWorkArea, 0);
	if (!bResult) {
		rWorkArea.left = rWorkArea.top = 0;
		rWorkArea.right = GetSystemMetrics(SM_CXSCREEN);
		rWorkArea.bottom = GetSystemMetrics(SM_CYSCREEN);
	}

	// Calculate new X position, then adjust for workarea
	xNew = rParent.left + ((wParent - wChild) /2);
	if (xNew < rWorkArea.left) {
		xNew = rWorkArea.left;
	} else if ((xNew+wChild) > rWorkArea.right) {
		xNew = rWorkArea.right - wChild;
	}

	// Calculate new Y position, then adjust for workarea
	yNew = rParent.top  + ((hParent - hChild) /2);
	if (yNew < rWorkArea.top) {
		yNew = rWorkArea.top;
	} else if ((yNew+hChild) > rWorkArea.bottom) {
		yNew = rWorkArea.bottom - hChild;
	}

	// Set it, and return
	return SetWindowPos (hwndChild, NULL, xNew, yNew, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
}


void InsertCaractere(int pos,char carac,char* text)
{
	int a;
	int len;
	char temptext[255];

	len = strlen(text);

	for(a=0;a<len+1;a++)
	{
		if(pos>a)
		{
			temptext[a]=*(text+a);
		}

		if(pos<a)
		{
			temptext[a]=*(text+a-1);
		}
		if(pos==a)
		{
			temptext[a]=carac;
		}
	}
	temptext[a]=0;
	strcpy(text,temptext);
}

void AjouterTVA(char *lptext,int TVA)
{
	char text[255];
	strcpy(text,lptext);
	if(TVA) strcat(text," TTC"); else strcat(text," HT"); 
	strcpy(lptext,text);
}

void AjouterPoint(char *lptext,int symbole)
{

	int lentext;
	int a;
	int b;
	char temptext[255];
	char text[255];
	int npoint;
	int len;
	char ch;
	int virgpasse=0;
	char symb[25];


		strcpy(text,lptext);

		if(text[0] != ' ') 
		{	
			len = strlen(text)+1;
			for(a=0;a<len;a++)
			{
				ch = text[a];
				temptext[a+1]=ch;

			}
			temptext[0]=' ';
			strcpy(text,temptext);
		}

		strcpy(temptext,text);

		lentext = strlen(text);

		text[0] = 0;
		b=0;
		npoint = 0;

		text[0] = ' ';
		for (a=lentext+1;a>-1;a--)
		{
			if(virgpasse)
			{
				if(b==3)b=0;
				b++;
				if(b==3)
				{
					/*wsprintf(buff,"%d",a);
					MessageBox(NULL,buff,"",0);*/
					if(a>=2) InsertCaractere(a,option.caracsep,text);
					npoint++;
				}
			}
			if(temptext[a]==',') virgpasse = 1;
		}


		if(option.caracsep==0)strcpy(text,temptext);
		if(npoint==0)strcpy(text,temptext);
	

	symb[0] =0;
	if(symbole != 0)
	{
		if(symbole>4)
		{
			strcat(symb," ");
			switch(symbole)
			{
			case 5:
			strcat(symb,"Kg");
			break;
			case 6:
			strcat(symb,"Tonnes(s)");
			break;
			case 7:
			strcat(symb,"Litre(s)");
			break;
			case 8:
			strcat(symb,"Mtre(s)");
			break;
			case 9:
			strcat(symb,"km");
			break;
			case 10:
			strcat(symb,"Pouce(s)");
			break;
			case 11:
			strcat(symb,"Cm");
			break;
			case 12:
			strcat(symb,option.convertiseurautre);
			break;
			}

		}
		else
		{
			strcat(symb," ");
			strcat(symb,option.courchar[symbole-1]);
		}

		strcat(text,symb);
	}

	strcpy(lptext,text);


}



double ConvertirMonnaie(double chiffre,int monnaie1,int monnaie2)
{
	double euro;
	double ret;

	if(monnaie1 < 5)
	{
		if(monnaie1==2)
		{
			ret = chiffre*option.cour[monnaie2-1];
			return (ret);
		}

		euro = chiffre/option.cour[monnaie1-1];

		if(monnaie2==2)
		{
			return (euro);
		}
		ret = euro*option.cour[monnaie2-1];
		return (ret);
	}

	if(monnaie1==10)
	{
		ret = chiffre*2.54;
		return (ret);
	}

	if(monnaie1==11)
	{
		ret = chiffre/2.54;
		return (ret);
	}

	return (chiffre);
}

void VerifLicence(HINSTANCE hInstance)
{

	char buff[8];
	HKEY hKey; //Handle de la cl ouverte
	DWORD lpType;
	DWORD Size;
	char bignum[8] =  {32,39,51,40,42,50,32,53};


	if(RegOpenKeyEx(HKEY_CURRENT_USER,"Software\\Cartel Espace\\BigNums" , 0, KEY_READ, &hKey) == ERROR_SUCCESS)
	{

		Size = 8;
		RegQueryValueEx(hKey, "bignums", 0, &lpType  ,(LPBYTE)&(buff) , &Size);

	}

	if(memcmp(bignum,buff,8)!=0)
	{
		DialogBox(hInstance,MAKEINTRESOURCE(IDD_LICENCE),NULL,(DLGPROC)Licence);
	}
}	

double ConvertHT(double prix)
{

	return (prix * 1/(1+(option.tauxtaxe/100)));

}

double ConvertTTC(double prix)
{

	return (prix + ((option.tauxtaxe/100.0)*prix));

}

void FermetureAnim(HWND hWnd)
{
	RECT rect;
	int a;
	int fin;

	infoouvert = 1;

	GetWindowRect(hWnd,&rect);

	fin = rect.top - (rect.bottom-rect.top);

	for(a=rect.top;a>fin;a=a-5)
	{
		Sleep(10);
		MoveWindow(hWnd,rect.left,a,(rect.right-rect.left),(rect.bottom-rect.top),TRUE);
	}

}

void OuvertureAnim(HWND hWnd)
{

	RECT rect;
	RECT rect2;
	int a;
	int b=0;
	int fin;
	int oldinfoouvert;

	oldinfoouvert = infoouvert;
	infoouvert = 1;

	GetWindowRect(hWnd,&rect);

	fin = rect.top - (rect.bottom-rect.top);


	if(option.anim)
	{
		for(a=fin;a<=0;a=a+5)
		{
			Sleep(1);
			MoveWindow(hWnd,rect.left,a,(rect.right-rect.left),(rect.bottom-rect.top),TRUE);
			GetUpdateRect(hWnd,&rect2,FALSE);
			InvalidateRect(hWnd,&rect2,TRUE);
			UpdateWindow(hWnd);

		}
	}

	MoveWindow(hWnd,rect.left,0,(rect.right-rect.left),(rect.bottom-rect.top),TRUE);

	infoouvert=oldinfoouvert;

}

void AfficheTouteLettre(double nombre1,double nombre2,char* valeur1, char* valeur2)
{
	char buff[1024];
//hnbrtl
	int a;
	int len;
	int virgulepasse=0;
	BOOL vide=FALSE;
//2147483646
	len = strlen(valeur1);

	ConvertirNombreVirgule(nombre1,buff);

	for(a=1;a<len;a++)
	{
		if(((*(valeur1+a))==' ')&&virgulepasse) 
		{
			strcat(buff," ");
			strcat(buff,(valeur1+a+1));
			break;
		}
		if(((*(valeur1+a))==',')) virgulepasse = 1;
	}

	virgulepasse=0;

	if(nombre1>2147483646.0) strcpy(buff," Nombre trop grand");
		
	SetDlgItemText(hnbrtl,IDC_EDIT1,&(buff[1]));

	if(((((option.convertiseuractiver)&&((option.symbole>0)&&(option.symbole<5)))||((option.convertiseursymbolemesure) && ((option.symbole==10)||(option.symbole==11)))))||option.activerconverttva) 
	{	
		len = strlen(valeur2);

		ConvertirNombreVirgule(nombre2,buff);	
		for(a=1;a<len;a++)
		{
			if(((*(valeur2+a))==' ')&&virgulepasse)
			{

				strcat(buff," ");
				strcat(buff,(valeur2+a+1));
				break;
			}
			if(((*(valeur2+a))==',')) virgulepasse = 1;
		}
	}
	else
	{
		strcpy(buff," vide");
		vide=TRUE;
	}

	if(!vide)
		if(nombre2>2147483646.0) strcpy(buff," Nombre trop grand");

	SetDlgItemText(hnbrtl,IDC_EDIT2,&(buff[1]));




}
void OuvertureAnimNBRTL(HWND hWnd)
{

	RECT rect;
	RECT rect2;
	int a;
	int b=0;
	int fin;
	int hauteurecran;
	int largeurecran;
	int sizebarre = 28;

	largeurecran = GetSystemMetrics(SM_CXSCREEN);
	hauteurecran = GetSystemMetrics(SM_CYSCREEN);

	GetWindowRect(hWnd,&rect);


	fin = hauteurecran-hautnbrtl-sizebarre;


	if(option.anim)
	{
		for(a=hauteurecran;a>=fin;a=a-5)
		{
			Sleep(1);
			MoveWindow(hWnd,0,a,largenbrtl,hautnbrtl,TRUE);
			GetUpdateRect(hWnd,&rect2,FALSE);
			InvalidateRect(hWnd,&rect2,TRUE);
			UpdateWindow(hWnd);

		}
	}

}

void AfficherNBRTL(HWND hWnd)
{
	if(option.DlgTL)
	{
		hnbrtl = CreateDialog(hInst,MAKEINTRESOURCE(IDD_NBRTL),GetDesktopWindow(),(DLGPROC)NbrTL);
		
		ShowWindow(hnbrtl,SW_SHOW);

		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);

		if(option.anim)OuvertureAnimNBRTL(hnbrtl);

		SetForegroundWindow(hWndCalc);
	}
	else
	{
		if(hnbrtl != NULL)PostMessage(hnbrtl,WM_CLOSE,0,0);
	}
}

