#include <windows.h>


#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <math.h>
#include <stdio.h>

#include "BigNum.h"
#include "resource.h"

HCURSOR oldCursor;

/************************************************************************\
 *    FUNCTION: WinMain
\************************************************************************/

int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	MSG msg;

	if (lpCmdLine[0] == 47 ) //Verifie si la ligne de commande commence par le caractre "/"
	{
		switch(lpCmdLine[1]) 
		{
			case 'd': //le caractre = "d"
				if ( MessageBox(NULL,"Etes-vous sur de vouloir dsinstaller BigNums ?","BigNums",52) == 6 ) 
					Desinstall();					
				return (FALSE);
				break;
		}

	}


	#ifdef _SANSLICENCE
	VerifLicence(hInstance);
	#endif



	if (!hPrevInstance) {
		// Perform instance initialization:
		if (!InitApplication(hInstance)) {
			return (FALSE);
		}
	}

	// Perform application initialization:
	if (!InitInstance(hInstance, nCmdShow)) {
		return (FALSE);
	}


	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) {		
		TranslateMessage(&msg);
		DispatchMessage(&msg);		
	}

	return (msg.wParam);

	lpCmdLine; // This will prevent 'unused formal parameter' warnings
}



/************************************************************************\
 *    FUNCTION: InitApplication
\************************************************************************/


BOOL InitApplication(HANDLE hInstance)       /* current instance             */
{
  WNDCLASS wc;

      wc.lpszClassName = "BigNum"; //Nom de l'application
      wc.lpfnWndProc = WndProc; //Fonction de procdure principale
      wc.style = CS_DBLCLKS | CS_VREDRAW | CS_HREDRAW; //Style de fentre
      wc.hInstance = hInstance; //Instance de l'application
	  wc.hIcon = NULL;
      wc.hCursor = LoadCursor( NULL, IDC_ARROW ); //Curseur de la fentre, classique
      wc.hbrBackground = (HBRUSH)NULL; //Fond de la fentre, classique
      wc.lpszMenuName = NULL; //Nom du menu dans la ressource
      wc.cbClsExtra = 0; //NULL
      wc.cbWndExtra = 0; //NULL


 if (!RegisterClass( &wc )) return(FALSE);//Enregistre les configs
 return(TRUE);
}



/************************************************************************\
 *    FUNCTION: InitInstance
\************************************************************************/

BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	HWND hWnd;

	hInst = hInstance; // Store instance handle in our global variable


	hWnd = CreateWindowEx(0x00000180,"BigNum","Cartel Espace : Recherche & Dveloppement", 0x16c00000,
		0, 0, 0, 0,
		NULL, NULL, hInstance, NULL);

	if (!hWnd) {
		return (FALSE);
	}


	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	AutoSizeWindow(hWnd);

	return (TRUE);
}


/************************************************************************\
 *    FUNCTION: WndProc
\************************************************************************/

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;


	switch (message) { 

		case WM_CREATE:
			OnCreate(hWnd,(LPCREATESTRUCT) lParam); 
			break;

		case WM_COMMAND:
			wmId    = LOWORD(wParam); // Remember, these are...
			wmEvent = HIWORD(wParam); // ...different for Win32!

			// Deal with the menu selections:
			switch (wmId) 
			{
			case ID_POLICE:
				OnPolice(hWnd);
				break;
			case ID_FOND:
				OnFond(hWnd);
				break;
			case ID_AUCUN:
				SetSyboleMonaitaire(hWnd,wmId);
				break;
			case ID_FRANC:
				SetSyboleMonaitaire(hWnd,wmId);
				break;
			case ID_EURO:
				SetSyboleMonaitaire(hWnd,wmId);
				break;
			case ID_DOLLAR:
				SetSyboleMonaitaire(hWnd,wmId);
				break;
			case ID_LIVRE:
				SetSyboleMonaitaire(hWnd,wmId);
				break;
			case ID_TOUJOURSVISIBLE:
				option.toujoursvisible = option.toujoursvisible ? FALSE : TRUE;
				SetTopMost(hWnd);
				break;
			}
			break;


		case WM_PAINT:
			hdc = BeginPaint (hWnd, &ps);

			OnPaint(hWnd,ps.hdc);

			EndPaint (hWnd, &ps);
			break;   
			
		case WM_ACTIVATE:
			SetForegroundWindow(hWndCalc);
			break;   
		
		case WM_TIMER:
			OnTimer(hWnd,wParam);
			break;

		case WM_RBUTTONUP:
			//AfficherMenuPop(hWnd);
			OnFond(hWnd);
			break;

		case WM_LBUTTONUP:
			//OnFond(hWnd);
			break;

		case WM_DESTROY:
			SavePref(hWnd);
			RemetVerrNum();
			DeleteObject(hBitmapFond);
			KillTimer(hWnd,1);
			DestroyWindow(hWndCalc);
			PostQuitMessage(0);
			break;

		default:
			return (DefWindowProc(hWnd, message, wParam, lParam));
	}
	return (0);
}

void OnCreate(HWND hWnd,LPCREATESTRUCT lpcs)
{
	ancientext[0]=0;

label1:
	GetHandleCalculatrice();
	if(!hWndCalc)
	{
		ShellExecute(NULL,"open","calc.exe","","",SW_SHOW);
		Sleep(1000);
		goto label1;
	}
		
	SetTimer(hWnd,1,1,NULL);
	Instal(hWnd);
	LoadPref(hWnd);
	SetTopMost(hWnd);
	ActiveVerrNum();
	CenterWindow(hWndCalc,GetDesktopWindow());
}

void GetHandleCalculatrice()
{
	char text[255];
	HWND hWndTemp;
	LONG style;

	hWndCalc = FindWindowEx(NULL,NULL,"SciCalc",NULL);

	if(!hWndCalc) return;

	hWndTemp = NULL;

	while(1)
	{
		hWndTemp = FindWindowEx(hWndCalc,hWndTemp,"Static",NULL);
		GetWindowText(hWndTemp,text,255);
		if((text[0]!=0))
			if((text[1]!='M'))
				if((text[0]!='M'))
					if((text[0]!='('))
					{
						style = GetWindowLong(hWndTemp,GWL_STYLE);
						if(style & WS_VISIBLE)
							break;
					}

	}


	hWndCalcStatic = hWndTemp;
}

void OnPaint(HWND hWnd,HDC hdc2)
{
	RECT rectarea,recttext,recttext2;
	char text[255];

	HBRUSH hBrushFond;
	HFONT font,oldFont;
	HBITMAP hbitmap,hbitmapOld;
	HDC hdc;
	double valeur;
	int a;
	int len;


	GetClientRect(hWnd,&rectarea);

	GetWindowText(hWndCalcStatic,text,255);

	strcpy(ancientext,text);

	AjouterPoint(text,option.symbole);

	hdc = CreateCompatibleDC(hdc2);
	hbitmap = CreateCompatibleBitmap (hdc2, rectarea.right - rectarea.left, rectarea.bottom - rectarea.top);
	hbitmapOld = (HBITMAP)SelectObject (hdc, hbitmap);


	switch(option.colorfondtype)
	{
	case 0:
		hBrushFond = CreateSolidBrush(option.colorfondsimple);

		FillRect(hdc,&rectarea,hBrushFond);

		DeleteObject(hBrushFond);
		break;
	case 1:
		DrawDegrade(hdc, option.colorfonddepart, option.colorfondarrive,0, 0, &rectarea);

		break;
	case 2:
		DrawBitmap (hdc,&rectarea, hBitmapFond, FALSE);
		break;
	}


	hBrushFond = CreateSolidBrush(option.colorfont);

	FrameRect(hdc,&rectarea,hBrushFond);

	DeleteObject(hBrushFond);

	recttext = rectarea;
	recttext.left++;
	recttext.top++;
	recttext.right--;
	recttext.bottom--;
	if(option.convertiseuractiver)recttext.bottom /=2;


	recttext2.left=recttext.left;
	recttext2.top=recttext.bottom;
	recttext2.right=recttext.right;
	recttext2.bottom=rectarea.bottom;

	SetTextColor(hdc,option.colorfont); 
	SetBkMode(hdc,TRANSPARENT) ;               //transparent text


	font = CreateFontIndirect(&option.font);
	oldFont = SelectObject(hdc,font);

	DrawText(hdc,text,strlen(text),&recttext,DT_SINGLELINE|DT_VCENTER|DT_LEFT);

	SelectObject(hdc,oldFont);
	DeleteObject(font);

	if(option.convertiseuractiver && (option.symbole!=0))
	{

		strcpy(text,ancientext);

		len = strlen(text);
		for(a=0;a<len;a++){if(text[a]==',')text[a]='.';}

		valeur = atof(text);

		sprintf(text,"%f", ConvertirMonnaie(valeur,option.symbole,option.convertiseursymbole+1));

		len = strlen(text);
		for(a=0;a<len;a++){if(text[a]=='.')text[a]=',';}

		len = strlen(text);
		for(a=len-1;a>0;a--){
			if(text[a]=='0')text[a]=0;else break;}
		

		AjouterPoint(text,option.convertiseursymbole+1);

		SetTextColor(hdc,option.colorfontconv); 

		font = CreateFontIndirect(&option.fontconv);
		oldFont = SelectObject(hdc,font);

		DrawText(hdc,text,strlen(text),&recttext2,DT_SINGLELINE|DT_VCENTER|DT_LEFT);

		SelectObject(hdc,oldFont);
		DeleteObject(font);
	}


	BitBlt(hdc2, rectarea.left, rectarea.top ,rectarea.right - rectarea.left, rectarea.bottom - rectarea.top ,hdc, 0, 0, SRCCOPY); 
 
	SelectObject (hdc, hbitmapOld);
	DeleteObject (hbitmap);

	DeleteDC(hdc); 
}

void OnTimer(HWND hWnd,int wID)
{
	char text[255];
	int style;

	style = GetWindowLong(hWnd,GWL_STYLE);

	GetHandleCalculatrice();

	if(!hWndCalc)DestroyWindow(hWnd);

	if(IsIconic(hWndCalc))
	{
		if((style & WS_VISIBLE))
			SetWindowPos(hWnd,NULL,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE|SWP_HIDEWINDOW);
	}
	else
	{
		if(!(style & WS_VISIBLE))
			SetWindowPos(hWnd,NULL,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE|SWP_SHOWWINDOW);

	}


	GetWindowText(hWndCalcStatic,text,255);
	
	if(strcmp(ancientext,text) != 0)
	{
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
	}


}

void AfficherMenuPop(HWND hWnd)
{
	HMENU hMenu;
	HMENU hMenuTrackPopup;
	POINT pt;

	//Charge le menu
	hMenu = LoadMenu(hInst, MAKEINTRESOURCE(IDR_MENUPOPUP));

	hMenuTrackPopup = GetSubMenu(hMenu, 0);

	if (option.toujoursvisible) CheckMenuItem(hMenuTrackPopup,ID_TOUJOURSVISIBLE,MF_CHECKED|MF_BYCOMMAND); else CheckMenuItem(hMenuTrackPopup,ID_TOUJOURSVISIBLE,MF_UNCHECKED|MF_BYCOMMAND);			
	CheckMenuRadioItem(hMenuTrackPopup,ID_AUCUN,ID_LIVRE,ID_AUCUN+option.symbole,MF_BYCOMMAND);

	GetCursorPos(&pt);
	
	//Affiche le menu
	TrackPopupMenu(hMenuTrackPopup,(UINT)NULL,
		pt.x,  pt.y, 0, hWnd, NULL);

	//Dtruit le menu
	DestroyMenu(hMenu);

}

void OnPolice(HWND hWnd)
{
		AutoSizeWindow(hWnd);
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
}

void FillInPropertyPage( PROPSHEETPAGE* psp, int idDlg, LPSTR pszProc, DLGPROC pfnDlgProc, int icon)
{
    psp->dwSize = sizeof(PROPSHEETPAGE);
    psp->dwFlags = PSP_USEICONID | PSP_USETITLE ;
    psp->hInstance = hInst;
    psp->pszTemplate = MAKEINTRESOURCE(idDlg);
    psp->pszIcon = MAKEINTRESOURCE(icon);
    psp->pfnDlgProc = pfnDlgProc;
    psp->pszTitle = pszProc;
    psp->lParam = 0;
}

int CALLBACK PropSheetProc( HWND hwndDlg, UINT uMsg, LPARAM lParam)
{

	//if(uMsg==PSCB_INITIALIZED)
	return (TRUE);

}
 

void OnFond(HWND hWnd)
{

    PROPSHEETPAGE psp[3];
    PROPSHEETHEADER psh;

	FillInPropertyPage( &psp[0], IDD_FOND, "Proprit d'affichage", (DLGPROC)Fond, 0);
	FillInPropertyPage( &psp[1], IDD_MONNAIE, "Monnaie", (DLGPROC)Monnaie, 0);
	FillInPropertyPage( &psp[2], IDD_ABOUT, "A propos de...", (DLGPROC)About, 0);


    psh.dwSize = sizeof(PROPSHEETHEADER);
    psh.dwFlags = PSH_PROPSHEETPAGE|PSH_USECALLBACK|PSH_NOAPPLYNOW;
    psh.hwndParent = hWnd;
    psh.pszCaption = "Options";
    psh.nPages = sizeof(psp) / sizeof(PROPSHEETPAGE);
    psh.ppsp = (LPCPROPSHEETPAGE) &psp;
	psh.pfnCallback = (PFNPROPSHEETCALLBACK)PropSheetProc;
	psh.hInstance = hInst;
    psh.nStartPage = 0;
    psh.pszIcon = NULL;

	if(PropertySheet(&psh))
	{
		OnOKFond();
		OnOKMonnaie();
		InvalidateRect(hWnd,NULL,TRUE);
		UpdateWindow(hWnd);
		AutoSizeWindow(hWnd);
		SetTopMost(hWnd);
		SavePref(hWnd);
	}
}

void SetTopMost(HWND hWnd)
{
	HWND hWndInsertAfter;

	hWndInsertAfter=option.toujoursvisible ? HWND_TOPMOST : HWND_NOTOPMOST;

	SetWindowPos(hWnd,hWndInsertAfter,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE);
	SetWindowPos(hWndCalc,hWndInsertAfter,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE);
}


void DrawBitmap (HDC hdc,RECT *SizeImage, HBITMAP hbm, BOOL Circle)
{
    BOOL f; //rsultat de StretchBlt
    HDC hdcBits; // Handle du Compatible DC 
    BITMAP bm; // Handle du Bitamp
	HRGN rgn; //Rgion du cercle d'affichage

	//Cre un compatible DC
    hdcBits = CreateCompatibleDC(hdc);
	//hdcBits = hdc;

	//Slctionne le BITMAP
    GetObject (hbm, sizeof(BITMAP), &bm);
    SelectObject(hdcBits,hbm);

	//Si SizeImage->right = -1 alors l'image sera  sa taille d'origine
	if (SizeImage->right == -1) SizeImage->right = bm.bmWidth;
	if (SizeImage->bottom == -1) SizeImage->bottom = bm.bmHeight;

	//Cre le cercle de la rgion 
	rgn = CreateEllipticRgn(SizeImage->left,
		SizeImage->top,
		SizeImage->right,
		SizeImage->bottom );

	//Si Circle est vrai alors selection de la rgion
	if (Circle) SelectClipRgn(hdc,rgn);

	//Affiche le BITMAP
    f = StretchBlt(
		hdc,
		SizeImage->left,
		SizeImage->top,
		SizeImage->right - SizeImage->left,
		SizeImage->bottom - SizeImage->top,
		hdcBits,
		0,
		0,
		bm.bmWidth, 
		bm.bmHeight,
		SRCCOPY
		);

	//Supprime les objets
	SelectClipRgn(hdc,NULL);
    DeleteDC(hdcBits);
	DeleteObject(rgn);
}

void DrawDegrade(HDC hdc, COLORREF CouleurDepart, COLORREF CouleurArrive,int Type, int Variente, LPRECT area)
{
	double divR; // Raport couleur/taille de la couleur rouge
	double divG; // Raport couleur/taille de la couleur verte
	double divB; // Raport couleur/taille de la couleur bleu
	double couleurR; //Couleur Rouge
	double couleurG; //Couleur Verte
	double couleurB; //Couleur Bleu
	double bottom; //y conner du ractancle
	double right; //x conner du ractancle
	HPEN hPen; //Handle du crayon
	HPEN oldPen; //Handle du crayon
	HBRUSH hBrush; //Handle de la brose
	HBRUSH oldBrush; //Handle de la brose
	double Rd; //Rouge de la couleur de dpart
	double Gd; //Vert de la couleur de dpart
	double Bd; //Bleu de la couleur de dpart
	int a; //Boucle
	double NbrT;


	couleurR = GetRValue (CouleurDepart);
	couleurG = GetGValue (CouleurDepart);
	couleurB = GetBValue (CouleurDepart);

	bottom = (float)area->bottom;
	right = (float)area->right;

	Rd = GetRValue (CouleurArrive) - couleurR;
	Gd = GetGValue (CouleurArrive) - couleurG;
	Bd = GetBValue (CouleurArrive) - couleurB;

	switch (Type) 
	{
		case 0:

			divR = 2 * Rd / bottom ;
			divG = 2 * Gd / bottom ;
			divB = 2 * Bd / bottom ;

			for (a = area->top + 1; a <= bottom - 1; a += 2)
			{

				hPen = CreatePen(PS_NULL ,1,RGB(couleurR,couleurG,couleurB));
				hBrush = CreateSolidBrush(RGB(couleurR,couleurG,couleurB));
				oldBrush = SelectObject(hdc,hBrush);
				oldPen = SelectObject(hdc,hPen);

				Rectangle(hdc,area->left,a - 1,area->right,a + 2);

				couleurR += divR; 
				couleurG += divG; 
				couleurB += divB; 

				SelectObject(hdc,oldPen);
				DeleteObject(hPen);
				SelectObject(hdc,oldBrush);
				DeleteObject(hBrush);

			}	

			break;

		case 1:

			divR = 2 * Rd / right ;
			divG = 2 * Gd / right ;
			divB = 2 * Bd / right ;

			for (a = area->left + 1; a <= right - 1; a += 2)
			{

				hPen = CreatePen(PS_NULL ,1,RGB(couleurR,couleurG,couleurB));
				hBrush = CreateSolidBrush(RGB(couleurR,couleurG,couleurB));
				oldBrush = SelectObject(hdc,hBrush);
				oldPen = SelectObject(hdc,hPen);


				Rectangle(hdc,a - 1,area->top,a + 2,area->bottom);

				couleurR += divR; 
				couleurG += divG; 
				couleurB += divB; 

				SelectObject(hdc,oldPen);
				DeleteObject(hPen);
				SelectObject(hdc,oldBrush);
				DeleteObject(hBrush);

			}

			break;
	
		case 2:

			NbrT = sqrt(2) * sqrt((bottom * bottom) + (right  * right ));

			for (a=1;a <= NbrT;a++)
			{
				couleurR += (Rd / NbrT); 
				couleurG += (Gd / NbrT); 
				couleurB += (Bd / NbrT); 

				hPen = CreatePen(PS_SOLID ,1,RGB(couleurR,couleurG,couleurB));
				oldPen = SelectObject(hdc,hPen);
				MoveToEx(hdc,a,area->top,NULL);
				LineTo(hdc,area->left  ,a);
				SelectObject(hdc,oldPen);
				DeleteObject(hPen);

			}
			break;

		case 3:

			NbrT = sqrt(2) * sqrt((bottom  * bottom ) + (right * right));

			for (a=1;a <= NbrT;a++)
			{
				couleurR += (Rd / NbrT); 
				couleurG += (Gd / NbrT); 
				couleurB += (Bd / NbrT); 

				hPen = CreatePen(PS_SOLID ,1,RGB(couleurR,couleurG,couleurB));
				oldPen = SelectObject(hdc,hPen);
				MoveToEx(hdc,area->right - a,area->top,NULL);
				LineTo(hdc,area->right ,a);
				SelectObject(hdc,oldPen);
				DeleteObject(hPen);
			}

			break;
	}


}


void AutoSizeWindow(HWND hWnd)
{
	int largeurecran;
	int hauteurecran;
	SIZE size;
	HFONT font,oldFont;
	RECT rect,rectarea;
	HDC hdc;

	largeurecran = GetSystemMetrics(SM_CXSCREEN);
	hauteurecran = GetSystemMetrics(SM_CYSCREEN);

	hdc = GetDC(hWnd);
	font = CreateFontIndirect(&option.font);
	oldFont = SelectObject(hdc,font);
	GetTextExtentPoint32(hdc,"0,23456789",10,&size);
	SelectObject(hdc,oldFont);
	DeleteObject(font);
	ReleaseDC(hWnd,hdc);

	GetWindowRect(hWnd,&rect);

	GetClientRect(hWnd,&rectarea);

	if(option.convertiseuractiver) size.cy *= 2;

	MoveWindow(hWnd,0,0,largeurecran,size.cy+20+(rect.bottom-rect.top-rectarea.bottom),TRUE);
}

void ActiveVerrNum()
{
	BYTE keys[256];
	GetKeyboardState((LPBYTE)&keys);
	remetrevernum = !keys[VK_NUMLOCK];
	keys[VK_NUMLOCK] = 1;
	SetKeyboardState((LPBYTE)&keys);

}

void RemetVerrNum()
{
	BYTE keys[256];

	if(remetrevernum)
	{
		GetKeyboardState((LPBYTE)&keys);
		keys[VK_NUMLOCK] = 0;
		SetKeyboardState((LPBYTE)&keys);
	}
}

void SetSyboleMonaitaire(HWND hWnd,UINT wID)
{
	option.symbole = wID-ID_AUCUN;
	InvalidateRect(hWnd,NULL,TRUE);
	UpdateWindow(hWnd);
}

BOOL CenterWindow (HWND hwndChild, HWND hwndParent)
{
	RECT    rChild, rParent, rWorkArea = {0,0,0,0};
	int     wChild, hChild, wParent, hParent;
	int     xNew, yNew;
	BOOL	bResult;

	// Get the Height and Width of the child window
	GetWindowRect (hwndChild, &rChild);
	wChild = rChild.right - rChild.left;
	hChild = rChild.bottom - rChild.top;

	// Get the Height and Width of the parent window
	GetWindowRect (hwndParent, &rParent);
	wParent = rParent.right - rParent.left;
	hParent = rParent.bottom - rParent.top;

	// Get the limits of the 'workarea'
	bResult = SystemParametersInfo( SPI_GETWORKAREA, sizeof(RECT), &rWorkArea, 0);
	if (!bResult) {
		rWorkArea.left = rWorkArea.top = 0;
		rWorkArea.right = GetSystemMetrics(SM_CXSCREEN);
		rWorkArea.bottom = GetSystemMetrics(SM_CYSCREEN);
	}

	// Calculate new X position, then adjust for workarea
	xNew = rParent.left + ((wParent - wChild) /2);
	if (xNew < rWorkArea.left) {
		xNew = rWorkArea.left;
	} else if ((xNew+wChild) > rWorkArea.right) {
		xNew = rWorkArea.right - wChild;
	}

	// Calculate new Y position, then adjust for workarea
	yNew = rParent.top  + ((hParent - hChild) /2);
	if (yNew < rWorkArea.top) {
		yNew = rWorkArea.top;
	} else if ((yNew+hChild) > rWorkArea.bottom) {
		yNew = rWorkArea.bottom - hChild;
	}

	// Set it, and return
	return SetWindowPos (hwndChild, NULL, xNew, yNew, 0, 0, SWP_NOSIZE | SWP_NOZORDER);
}

BOOL APIENTRY About(HWND hDlg,UINT message, WPARAM wParam, LPARAM lParam)
{

	int wmId,wmEvent,nbrCaractere,nHeight;
	RECT rc,rc2;
	POINT point;

	switch (message)
	{
		case WM_INITDIALOG:
			nbrCaractere = SendDlgItemMessage (hDlg, IDC_TITRE,WM_GETTEXTLENGTH,0,0);
			nHeight = -MulDiv(8, GetDeviceCaps(GetDC(hDlg), LOGPIXELSY), 72);
			SendDlgItemMessage(hDlg, IDC_TITRE,WM_SETFONT, (WPARAM)CreateFont(nHeight,  0, 0,0,700,FALSE,FALSE,FALSE, DEFAULT_CHARSET , OUT_DEFAULT_PRECIS ,CLIP_DEFAULT_PRECIS , DEFAULT_QUALITY , DEFAULT_PITCH, "MS Sans Serif" ),TRUE );
			SendDlgItemMessage(hDlg, IDC_INFO,WM_SETFONT, (WPARAM)CreateFont(nHeight,  0, 0,0,700,FALSE,FALSE,FALSE, DEFAULT_CHARSET , OUT_DEFAULT_PRECIS ,CLIP_DEFAULT_PRECIS , DEFAULT_QUALITY , DEFAULT_PITCH, "MS Sans Serif" ),TRUE );
			SendDlgItemMessage(hDlg, IDC_PROG,WM_SETFONT, (WPARAM)CreateFont(nHeight,  0, 0,0,700,FALSE,FALSE,FALSE, DEFAULT_CHARSET , OUT_DEFAULT_PRECIS ,CLIP_DEFAULT_PRECIS , DEFAULT_QUALITY , DEFAULT_PITCH, "MS Sans Serif" ),TRUE );
			oldCursor = 0;
			return (TRUE);

		case WM_SETCURSOR:

			if (( wParam == (WPARAM)GetDlgItem(hDlg,IDC_PROG)) && (HIWORD(lParam)==WM_MOUSEMOVE))
			{
				if ((GetCapture() != hDlg) &&
				  ((hDlg != NULL) ) )
				{
					oldCursor = LoadCursor(hInst,MAKEINTRESOURCE(IDC_MAIN));
					oldCursor = SetCursor(oldCursor); 
					SetCapture(hDlg);
				}
			}

			break;


		case WM_MOUSEMOVE:

			GetWindowRect(GetDlgItem(hDlg,IDC_PROG),&rc);
			GetWindowRect(hDlg,&rc2);

			rc.left -= rc2.left;
			rc.top -= rc2.top;
			rc.right -= rc2.left;
			rc.bottom -= rc2.top;

			point.x = LOWORD(lParam); 
			point.y = HIWORD(lParam);  

			if (!PtInRect(&rc,point))
			{
				ReleaseCapture();
				if(oldCursor != 0)
				{

					SetCursor(oldCursor); 
					oldCursor=0;
				}
			}

			break;

		case WM_COMMAND:
			wmId    = LOWORD(wParam); // Remember, these are...
			wmEvent = HIWORD(wParam); // ...different for Win32!


			if((wmEvent==STN_CLICKED)&&(wmId==IDC_PROG)) ShellExecute(hDlg,"open","http://perso.wanadoo.fr/thema/fk","","",SW_SHOW);



			// Deal with the menu selections:
			switch (wmId) 
			{


			}
			break;



	}
	return (FALSE);   
}

void AjouterPoint(char *lptext,int symbole)
{

	int lentext;
	int a;
	int b;
	char temptext[255];
	char text[255];
	int npoint;
	int nvirg;
	int nvirgp;
	int len;
	char ch;
	int virgpasse=0;


		strcpy(text,lptext);

		if(text[0] != ' ') 
		{	
			len = strlen(text)+1;
			for(a=0;a<len;a++)
			{
				ch = text[a];
				temptext[a+1]=ch;

			}
			temptext[0]=' ';
			strcpy(text,temptext);
		}

		strcpy(temptext,text);

		lentext = strlen(text);

		text[0] = 0;
		b=0;
		npoint = 0;

		text[0] = ' ';
		for (a=lentext-1;a>-1;a--)
		{
			if(virgpasse)
			{
				if(b==3)b=0;
				b++;
				if(b==3)
				{
					text[a-2+npoint] = temptext[a-2];
					text[a-1+npoint] = temptext[a-1];
					text[a+npoint] = temptext[a];
					text[a+1+npoint] = option.caracsep;
					npoint++;
				}
			}
			if(temptext[a]==',') virgpasse = 1;
		}


		if(b==1)
		{
			text[(npoint*4)+1] = temptext[a-1];
		}
		if(b==2)
		{
			text[(npoint*4)+1] = temptext[a-2];
			text[(npoint*4)+2] = temptext[a-1];
		}
		if(b==3) b=0;

		text[(npoint*4)+b+1] = ',';
		text[(npoint*4)+b+2] = 0;
		nvirgp = (npoint*4)+b+1;
		nvirg =	nvirgp - npoint;

		if(	text[(npoint*4)+b] == option.caracsep)
		{
			text[(npoint*4)+b] = ',';
			text[(npoint*4)+b+1] = 0;
			nvirgp = (npoint*4)+b;
			nvirg =	nvirgp - npoint+1;
		}



		for(a=0;a < (lentext-nvirg);a++)
		{

			text[a+nvirgp+1] = temptext[a+nvirg+1];

		}

		if(option.caracsep==0)strcpy(text,temptext);
		if(npoint==0)strcpy(text,temptext);
	

	switch(symbole)
	{
	case 1:
		strcat(text," F");
		break;
	case 2:
		strcat(text," ");
		break;
	case 3:
		strcat(text," $");
		break;
	case 4:
		strcat(text," ");
		break;
	}

	strcpy(lptext,text);


}

double ConvertirMonnaie(double chiffre,int monnaie1,int monnaie2)
{
	double euro;
	double ret;
	if(monnaie1==2)
	{
		ret = chiffre*option.cour[monnaie2-1];
		return (ret);
	}

	euro = chiffre/option.cour[monnaie1-1];

	if(monnaie2==2)
	{
		return (euro);
	}
	ret = euro*option.cour[monnaie2-1];
	return (ret);


}

void VerifLicence(HINSTANCE hInstance)
{

	char buff[8];
	HKEY hKey; //Handle de la cl ouverte
	DWORD lpType;
	DWORD Size;
	char bignum[8] =  {32,39,51,40,42,50,32,53};


	if(RegOpenKeyEx(HKEY_CURRENT_USER,"Software\\Cartel Espace\\BigNums" , 0, KEY_READ, &hKey) == ERROR_SUCCESS)
	{

		Size = 8;
		RegQueryValueEx(hKey, "bignums", 0, &lpType  ,(LPBYTE)&(buff) , &Size);

	}

	if(memcmp(bignum,buff,8)!=0)
	{
		DialogBox(hInstance,MAKEINTRESOURCE(IDD_LICENCE),NULL,(DLGPROC)Licence);
	}
}