#include <windows.h>


#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <memory.h>
#include <stdio.h>
#include <shlobj.h>
#include <shlguid.h>


#include "BigNum.h"
#include "resource.h"




HRESULT CreateLink(LPCSTR lpszPathObj, LPSTR lpszPathLink, LPSTR lpszDesc, LPSTR pszIconPath, int piIcon, LPSTR lpszArgu, LPSTR lpszWorkDirec, int ShowCmd, WORD wHotkey) 
{     
	HRESULT hres;     
	IShellLink* psl; 

	CoInitialize(NULL);
 
    // Get a pointer to the IShellLink interface. 
    hres = CoCreateInstance(&CLSID_ShellLink, NULL, 
        CLSCTX_INPROC_SERVER, &IID_IShellLink, &psl); 
    
	if (SUCCEEDED(hres)) {         
		IPersistFile* ppf;  
        
		// Set the path to the shortcut target, and add the 
        // description.         
		psl->lpVtbl->SetPath(psl, lpszPathObj); 
        psl->lpVtbl->SetDescription(psl, lpszDesc);  
        psl->lpVtbl->SetIconLocation(psl, pszIconPath, piIcon);     
        psl->lpVtbl->SetArguments(psl, lpszArgu);   	
        psl->lpVtbl->SetWorkingDirectory(psl, lpszWorkDirec);	
        psl->lpVtbl->SetShowCmd(psl, ShowCmd);	
        psl->lpVtbl->SetHotkey(psl, wHotkey );
		
		// Query IShellLink for the IPersistFile interface for saving the 
       // shortcut in persistent storage. 
        hres = psl->lpVtbl->QueryInterface(psl, &IID_IPersistFile, 
            &ppf);    
		
		if (SUCCEEDED(hres)) { 
            WORD wsz[MAX_PATH];              // Ensure that the string is ANSI. 
            MultiByteToWideChar(CP_ACP, 0, lpszPathLink, -1, 
                wsz, MAX_PATH);  
            
			// Save the link by calling IPersistFile::Save. 
            hres = ppf->lpVtbl->Save(ppf, wsz, TRUE); 
            ppf->lpVtbl->Release(ppf);         
		} 
        psl->lpVtbl->Release(psl);     
	}   
	
	return SUCCEEDED(hres); 

} 

int GetDirectory(LPCSTR path,int nPath, LPTSTR directory)
{
	int a;
	for (a=0; a<nPath; a++)
	{
		if (*(path + a) == 0) break;
	}

	for (a=a; a>=0; a--)
	{
		if (*(path + a) == 92) {strcpy(directory, path); *(directory + a) = 0; break;}
	}

	return  a;
}

int GetRegInt(HKEY hKey, LPCTSTR buff)
{
	DWORD lpType;
	char buff2[15];
	DWORD Size = 15;
	buff2[0] = 0;
	RegQueryValueEx(hKey, buff, 0, &lpType, (LPBYTE)buff2, &Size);
 	return atoi(buff2);

}
BOOL GetRegBool(HKEY hKey,LPCTSTR buff)
{
	DWORD lpType;
	char buff2[15];
	DWORD Size = 15;
	buff2[0] = 0;
	RegQueryValueEx(hKey, buff, 0, &lpType, (LPBYTE)buff2, &Size);
	if (buff2[0] == 121) return TRUE; else return FALSE;


}
void LoadPref(HWND hWnd)
{
	HKEY hKey; //Handle de la cl ouverte
	DWORD lpType;
	DWORD Size;
	char buff[5];

	if(RegOpenKeyEx(HKEY_CURRENT_USER,"Software\\Cartel Espace\\BigNums" , 0, KEY_READ, &hKey) == ERROR_SUCCESS)
	{

		Size = sizeof(LOGFONT);
		RegQueryValueEx(hKey, "Font", 0, &lpType  ,(LPBYTE)&(option.font) , &Size);
		
		Size = sizeof(LOGFONT);		
		RegQueryValueEx(hKey, "Font Conv", 0, &lpType  ,(LPBYTE)&(option.fontconv) , &Size);

		Size = sizeof(typeoptionnbrtl);		
		RegQueryValueEx(hKey, "NbrTl", 0, &lpType  ,(LPBYTE)&(option.optionnbrtl) , &Size);

		Size = 255;
		RegQueryValueEx(hKey, "Fond Path Image", 0, &lpType  ,(LPBYTE)option.fondpathimage, &Size);

		Size = 255;
		RegQueryValueEx(hKey, "Path Son", 0, &lpType  ,(LPBYTE)option.pathson, &Size);

		Size = 20;
		RegQueryValueEx(hKey, "Convertisseur Autre", 0, &lpType   ,(LPBYTE) &(option.convertiseurautre) , &Size);

		Size = 20;
		RegQueryValueEx(hKey, "Autre Monnaie", 0, &lpType   ,(LPBYTE) &(option.autremonnaie) , &Size);

		option.convertiseursymbolemesure=GetRegBool(hKey,"Activer Conv Symbole Mesure");

		Size = 5;
		RegQueryValueEx(hKey, "Caractere de Separation", 0, &lpType  ,(LPBYTE)buff, &Size);
		option.caracsep=buff[0];

		Size = sizeof(double)*4;
		if(RegQueryValueEx(hKey, "Cour", 0, &lpType  ,(LPBYTE)&(option.cour) , &Size)!=ERROR_SUCCESS)MessageBox(NULL,"Erreur de chargement de dans la base de registre (Cour)","Erreur",16);

		Size = sizeof(double);
		if(RegQueryValueEx(hKey, "Taux Taxe", 0, &lpType  ,(LPBYTE)&(option.tauxtaxe) , &Size)!=ERROR_SUCCESS)MessageBox(NULL,"Erreur de chargement de dans la base de registre (Cour)","Erreur",16);

		Size = sizeof(char)*80;
		if(RegQueryValueEx(hKey, "Char Cour", 0, &lpType  ,(LPBYTE)&(option.courchar) , &Size)!=ERROR_SUCCESS)MessageBox(NULL,"Erreur de chargement de dans la base de registre (Char Cour)","Erreur",16);

		option.colorfont=GetRegInt(hKey,"Color Font");

		option.colorfontconv=GetRegInt(hKey,"Color Font Conv");

		option.colorfondtype=GetRegInt(hKey,"Color Fond Type");

		option.colorfondsimple=GetRegInt(hKey,"Color Fond Simple");
		option.colorfonddepart=GetRegInt(hKey,"Color Fond Depart");
		option.colorfondarrive=GetRegInt(hKey,"Color Fond Arrive");

		option.toujoursvisible=GetRegBool(hKey,"Toujours Visible");

		option.anim=GetRegBool(hKey,"Animation");
		option.DlgTL=GetRegBool(hKey,"DlgTL");

		option.symbole=GetRegInt(hKey,"Symbole");
		option.convertiseursymbole=GetRegInt(hKey,"Convertisseur Symbole");
		option.voix=GetRegInt(hKey,"Voix");

		option.convertiseuractiver=GetRegBool(hKey,"Convertisseur Active");

		option.activerconverttva=GetRegBool(hKey,"Activer Convertisseur TVA");
		option.converttva=GetRegInt(hKey,"Convertie TVA");
		option.nonconverttva=GetRegInt(hKey,"Non Convertie TVA");

		option.info=GetRegBool(hKey,"Info");
		option.jouerson=GetRegBool(hKey,"Jouer Son");

		hBitmapFond = LoadImage(hInst,option.fondpathimage,IMAGE_BITMAP,0,0,LR_LOADFROMFILE);
		hBitmapFondNbrTl = LoadImage(hInst,option.optionnbrtl.fondpathimage,IMAGE_BITMAP,0,0,LR_LOADFROMFILE);
		
		RegCloseKey(hKey); 
	}
	
}

void SetRegInt(HKEY hKey,int Value, LPCTSTR buff)
{
	int n;
	char buff2[15];

	n = sprintf(buff2,"%d", Value); 
	RegSetValueEx(hKey, buff , 0, REG_SZ  ,(LPBYTE) &buff2 , n+1);

}

void SetRegBool(HKEY hKey,BOOL Value, LPCTSTR buff)
{

    char buff2[5];

	if (Value) strcpy(buff2,"yes"); else strcpy(buff2,"no"); 

	RegSetValueEx(hKey, buff, 0, REG_SZ  ,(LPBYTE) &buff2 , 4);

}

void SavePref(HWND hWnd)
{
	HKEY hKey;

	if(RegCreateKeyEx(HKEY_CURRENT_USER,"Software\\Cartel Espace\\BigNums" , 0, "BigNums", 0,
	KEY_ALL_ACCESS, NULL, &hKey, NULL) == ERROR_SUCCESS)
	{
		RegSetValueEx(hKey, "Font", 0, REG_BINARY   ,(LPBYTE) &(option.font) , sizeof(LOGFONT));

		RegSetValueEx(hKey, "NbrTl", 0, REG_BINARY   ,(LPBYTE) &(option.optionnbrtl) , sizeof(typeoptionnbrtl));
 
		RegSetValueEx(hKey, "Font Conv", 0, REG_BINARY   ,(LPBYTE) &(option.fontconv) , sizeof(LOGFONT));

		if(RegSetValueEx(hKey, "Cour", 0, REG_BINARY   ,(LPBYTE) &(option.cour) , sizeof(double)*4)!=ERROR_SUCCESS)MessageBox(NULL,"Erreur d'enregistrement dans la base de registre (Cour)","Erreur",16);

		if(RegSetValueEx(hKey, "Char Cour", 0, REG_BINARY   ,(LPBYTE) &(option.courchar) , sizeof(char)*80)!=ERROR_SUCCESS)MessageBox(NULL,"Erreur d'enregistrement dans la base de registre (Char Cour)","Erreur",16);

		if(RegSetValueEx(hKey, "Taux Taxe", 0, REG_BINARY   ,(LPBYTE) &(option.tauxtaxe) , sizeof(double))!=ERROR_SUCCESS)MessageBox(NULL,"Erreur d'enregistrement dans la base de registre (Char Cour)","Erreur",16);

		RegSetValueEx(hKey, "Fond Path Image", 0, REG_SZ   ,(LPBYTE) &(option.fondpathimage) , 255);

		RegSetValueEx(hKey, "Path Son", 0, REG_SZ   ,(LPBYTE) &(option.pathson) , 255);

		RegSetValueEx(hKey, "Caractere de Separation", 0, REG_SZ   ,(LPBYTE) &(option.caracsep) , 1);

		RegSetValueEx(hKey, "Convertisseur Autre", 0, REG_SZ   ,(LPBYTE) &(option.convertiseurautre) , 20);

		RegSetValueEx(hKey, "Autre Monnaie", 0, REG_SZ   ,(LPBYTE) &(option.autremonnaie) , 20);

		SetRegBool(hKey,option.convertiseursymbolemesure,"Activer Conv Symbole Mesure");

		SetRegInt(hKey,option.colorfont,"Color Font");

		SetRegInt(hKey,option.colorfontconv,"Color Font Conv");

		SetRegInt(hKey,option.colorfondtype,"Color Fond Type");

		SetRegInt(hKey,option.colorfondsimple,"Color Fond Simple");
		SetRegInt(hKey,option.colorfonddepart,"Color Fond Depart");
		SetRegInt(hKey,option.colorfondarrive,"Color Fond Arrive");

		SetRegBool(hKey,option.toujoursvisible,"Toujours Visible");

		SetRegBool(hKey,option.anim,"Animation");
		SetRegBool(hKey,option.DlgTL,"DlgTL");

		SetRegInt(hKey,option.symbole,"Symbole");
		SetRegInt(hKey,option.convertiseursymbole,"Convertisseur Symbole");
		SetRegInt(hKey,option.voix,"Voix");

		SetRegBool(hKey,option.convertiseuractiver,"Convertisseur Active");
	
		SetRegInt(hKey,option.converttva,"Convertie TVA");
		SetRegInt(hKey,option.nonconverttva,"Non Convertie TVA");
		SetRegBool(hKey,option.activerconverttva,"Activer Convertisseur TVA");
		
		SetRegBool(hKey,option.info,"Info");
		SetRegBool(hKey,option.jouerson,"Jouer Son");
	
		RegCloseKey(hKey); 
	}



}

void Instal(HWND hWnd)
{

	HKEY hKey;
	char exe[255];
	LPITEMIDLIST ppidl;
	char path[255];
	char directory[255];
	char FileName[] = "\\BigNums.lnk";
	char PathLink[255];
	char buff[255];

    if(RegOpenKeyEx(HKEY_LOCAL_MACHINE,"Software\\Cartel Espace\\BigNums\\1.1" , 0, KEY_ALL_ACCESS, &hKey) != ERROR_SUCCESS)
    {
		RegCreateKeyEx(HKEY_LOCAL_MACHINE,"Software\\Cartel Espace\\BigNums\\1.1" , 0, "BigNums", 0,KEY_ALL_ACCESS, NULL, &hKey, NULL);

		//Obtien le chemin de l'excutable 
		GetModuleFileName(NULL,exe,255);
		GetDirectory(exe, MAX_PATH, directory);

		
		if(RegCreateKeyEx(HKEY_LOCAL_MACHINE,"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\App Paths\\BIGNUMS.EXE", 0, "BigNums" , 0, KEY_ALL_ACCESS, NULL, &hKey, NULL) == ERROR_SUCCESS)		
		{
			RegSetValueEx(hKey, "", 0, REG_SZ, (LPBYTE) &exe, 255);
			RegCloseKey(hKey); 
		}

		if(RegCreateKeyEx(HKEY_LOCAL_MACHINE,"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\BigNums" , 0, "BigNums", 0,KEY_ALL_ACCESS, NULL, &hKey, NULL) == ERROR_SUCCESS)
		{
			if(RegSetValueEx(hKey, "DisplayName", 0, REG_SZ, (LPBYTE) "BigNums", 255) != ERROR_SUCCESS) ;	
			wsprintf(buff,"%s /d",exe);
			if(RegSetValueEx(hKey, "UninstallString", 0, REG_SZ, (LPBYTE) &buff, 255) != ERROR_SUCCESS) ;		
			RegCloseKey(hKey); 
		}

		if(RegOpenKeyEx(HKEY_LOCAL_MACHINE,"Software\\Microsoft\\Windows\\Help" , 0, KEY_ALL_ACCESS, &hKey) == ERROR_SUCCESS)		
		{
			RegSetValueEx(hKey, "Bignums.hlp", 0, REG_SZ, (LPBYTE) &directory, 255);
			RegCloseKey(hKey); 
		}


		SHGetSpecialFolderLocation(NULL,CSIDL_DESKTOP,&ppidl);
		SHGetPathFromIDList(ppidl,path);
		wsprintf(PathLink,"%s%s",path,FileName);

		CreateLink(exe, PathLink, "Solitaire", exe, 0, "", directory, SW_SHOWNORMAL , (WORD)NULL  );

		SHGetSpecialFolderLocation(NULL,CSIDL_PROGRAMS,&ppidl);
		SHGetPathFromIDList(ppidl,path);
		wsprintf(PathLink,"%s%s",path,FileName);

		CreateLink(exe, PathLink, "Solitaire", exe, 0, "", directory, SW_SHOWNORMAL , (WORD)NULL  );


		option.font.lfHeight =-64;    
		option.font.lfWidth =0;    
		option.font.lfEscapement =0;    
		option.font.lfOrientation= 0; 
		option.font.lfWeight = 700;    
		option.font.lfItalic = 1;    
		option.font.lfUnderline = 0;    
		option.font.lfStrikeOut = 0; 
		option.font.lfCharSet = DEFAULT_CHARSET;    
		option.font.lfOutPrecision = OUT_DEFAULT_PRECIS;    
		option.font.lfClipPrecision = CLIP_DEFAULT_PRECIS; 
		option.font.lfQuality = DEFAULT_QUALITY;    
		option.font.lfPitchAndFamily = DEFAULT_PITCH;    
		strcpy(option.font.lfFaceName, "Comic Sans MS");

		option.fontconv = option.font;

		option.colorfontconv= RGB(255,0,0);
		option.colorfont= RGB(255,255,0);
		option.colorfondtype=1;
		option.colorfondsimple=RGB(0,0,255);
		option.colorfonddepart=RGB(0,0,255);
		option.colorfondarrive=RGB(0,0,0);
		strcpy(option.fondpathimage,"");
		option.toujoursvisible=1;
		option.license=0;
		option.symbole=0;
		option.anim = 1;
		option.DlgTL = 0;

		option.voix = -1;

		option.convertiseursymbole=1;
		option.convertiseuractiver=0;
		option.cour[0]=6.5596;
		option.cour[1]=1;
		option.cour[2]=0.9619;
		option.cour[3]=0.6010;

		strcpy(option.courchar[0],"F");
		option.courchar[1][0]=(char)128;
		option.courchar[1][1]=0;
		strcpy(option.courchar[2],"$");
		strcpy(option.courchar[3],"");

		option.caracsep = '.';

		strcpy(option.convertiseurautre,"");
		strcpy(option.autremonnaie,"Livre");
		option.convertiseursymbolemesure=FALSE;

		option.activerconverttva = FALSE;
		option.converttva = 0;
		option.nonconverttva = 1;
		option.tauxtaxe = 19.6;

		option.info=TRUE;

		option.jouerson = TRUE;

		option.optionnbrtl.font=option.font;
		option.optionnbrtl.fontconv=option.font;

		option.optionnbrtl.colorfontconv= RGB(255,0,0);
		option.optionnbrtl.colorfont= RGB(255,255,0);
		option.optionnbrtl.colorfondsimple=RGB(0,0,255);
		option.optionnbrtl.colorfonddepart=RGB(0,0,255);
		option.optionnbrtl.colorfondarrive=RGB(0,0,0);
		option.optionnbrtl.colorfondtext=RGB(0,0,0);
		option.optionnbrtl.colorfondtextnon=RGB(0,0,0);
		strcpy(option.optionnbrtl.fondpathimage,"");
		option.optionnbrtl.colorfondtype=1;

		strcpy(option.pathson,"C:\\WINDOWS\\MEDIA\\RECYCLE.WAV");

		hBitmapFond = LoadImage(hInst,option.fondpathimage,IMAGE_BITMAP,0,0,LR_LOADFROMFILE);
		hBitmapFondNbrTl = LoadImage(hInst,option.optionnbrtl.fondpathimage,IMAGE_BITMAP,0,0,LR_LOADFROMFILE);
		
		SavePref(hWnd);
	}
}
void Desinstall()
{
	LPITEMIDLIST ppidl;
	char path[MAX_PATH];
	char FileName[] = "\\BigNums.lnk";
	char PathLink[MAX_PATH];

	HKEY hKey;

	SHGetSpecialFolderLocation(NULL,CSIDL_DESKTOP,&ppidl);
	SHGetPathFromIDList(ppidl,path);
	wsprintf(PathLink,"%s%s",path,FileName);
	DeleteFile(PathLink);

	if(RegOpenKeyEx(HKEY_CURRENT_USER,"Software\\Cartel Espace" , 0, KEY_ALL_ACCESS, &hKey) == ERROR_SUCCESS)
	{
		RegDeleteKey(hKey,"BigNums");
		RegCloseKey(hKey); 
	}

	if(RegOpenKeyEx(HKEY_LOCAL_MACHINE,"Software\\Cartel Espace" , 0, KEY_ALL_ACCESS, &hKey) == ERROR_SUCCESS)
	{
		RegDeleteKey(hKey,"BigNums");
		RegCloseKey(hKey); 
	}
	
	if(RegOpenKeyEx(HKEY_LOCAL_MACHINE,"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\App Paths" , 0, KEY_ALL_ACCESS, &hKey) == ERROR_SUCCESS)		
	{
		RegDeleteKey(hKey,"BIGNUMS.EXE");
		RegCloseKey(hKey); 
	}

	if(RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall", 0, KEY_ALL_ACCESS, &hKey) == ERROR_SUCCESS)		
	{
		RegDeleteKey(hKey,"BigNums");
		RegCloseKey(hKey); 
	}

	if(RegOpenKeyEx(HKEY_LOCAL_MACHINE,"Software\\Microsoft\\Windows\\Help" , 0, KEY_ALL_ACCESS, &hKey) == ERROR_SUCCESS)		
	{
		RegDeleteValue(hKey, "Bignums.hlp");			
		RegCloseKey(hKey); 
	}


	MessageBox(NULL,"BigNums  t dsinstall avec succs", "BigNums", 64);
}

