/*************************************************************
/
/ Nom du fichier : StrChiffre.c
/
/ Auteur : Florent Kaisser
/
/ Dernire modification : 20 Juin 2000
/ 
/ Modifi pour BigNums
/
/ Description : Ce programme permet de convertir un nombre
/               en chiffre en toute lettre. 
/				Exemple : 1200 -> "Mille deux cent"
/
/*************************************************************/

#include <string.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>

int stop;

char dizaine[][20] = {""," dix"," vingt"," trente"," quarente"," cinquante"," soixante"," "," quatre vingt"};
char unite[][20] = {" zero"," un"," deux"," trois"," quatre"," cinq"," six"," sept"," huit"," neuf"," dix"," onze"," douze"," treize"," quatorze"," quinze"," seize"};
char GrandeUnite[][20] = {" cent"," mille"," million"," milliard"};
char virgule[20] = " virgule";

void ConvertDizaine(int nombre, char* string)
{
	strcat(string,unite[nombre]);
}


void ConvertCentaine(int nombre, char* string)
{
	int a;
	int n;


	if((nombre >= 0)&&(nombre < 17))
	{
		ConvertDizaine(nombre,string);
	}

	if((nombre > 16)&&(nombre < 20))
	{
		strcat(string,dizaine[1]);
		ConvertDizaine(nombre-10,string);
	}

	for(a=2;a<6;a++)
	{
		n = a*10;
		if((nombre >= (n))&&(nombre < (n+10) ))
		{
			strcat(string,dizaine[a]);
			if(nombre!=n) ConvertDizaine(nombre-n,string);
		}

	}

	if((nombre >= 60)&&(nombre < 80))
	{
		strcat(string,dizaine[6]);
		ConvertCentaine(nombre-60,string);
	}

	if((nombre >= 80)&&(nombre < 100))
	{
		strcat(string,dizaine[8]);
		ConvertCentaine(nombre-80,string);
	}

}

void ConvertMillier(int nombre, char* string)
{
	int a;
	int n;
	char temp[20];

	temp[0] = 0;


	for(a=1;a<10;a++)
	{
		n = a*100;
		if((nombre >= (n))&&(nombre < (n+100) ))
		{
			if(a != 1)
			{
				ConvertDizaine(a,temp);
				strcat(string,temp);	
			}
			strcat(string,GrandeUnite[0]);
			if(nombre!=n) ConvertCentaine(nombre-n,string);
		}

	}

}


void ConvertirUnAMille(int Nombre, char* string)
{
	//char text[1024];


	if(Nombre < 100)ConvertCentaine(Nombre,string);
	if((Nombre >= 100)&&(Nombre < 1000))ConvertMillier(Nombre,string);


}


void ConvertMillion(int nombre, char* string)
{
	int n;

	n = nombre/1000;

	if(n != 1)ConvertirUnAMille(n, string);

	strcat(string, GrandeUnite[1]);

	if(nombre!=(n*1000))ConvertirUnAMille(nombre-(n*1000), string);

}

void ConvertirUnAMillion(int Nombre, char* string)
{
	//char text[1024];


	if(Nombre < 1000)ConvertirUnAMille(Nombre,string);
	if((Nombre >= 1000)&&(Nombre < 1000000))ConvertMillion(Nombre,string);


}


void ConvertMilliard(int nombre, char* string)
{
	int n;

	n = nombre/1000000;

	ConvertirUnAMille(n, string);

	strcat(string, GrandeUnite[2]);

	if(nombre!=(n*1000000))ConvertirUnAMillion(nombre-(n*1000000), string);

}
void ConvertirUnAMilliard(int Nombre, char* string)
{
	//char text[1024];


	if(Nombre < 1000)ConvertirUnAMille(Nombre,string);
	if((Nombre >= 1000)&&(Nombre < 1000000))ConvertMillion(Nombre,string);
	if((Nombre >= 1000000)&&(Nombre < 1000000000))ConvertMilliard(Nombre,string);


}


void ConvertMilleMilliard(int nombre, char* string)
{
	int n;

	n = nombre/1000000000;

	ConvertirUnAMille(n, string);

	strcat(string, GrandeUnite[3]);

	if(nombre!=(n*1000000000))ConvertirUnAMilliard(nombre-(n*1000000000), string);

}

void ConvertMax(int Nombre, char* string)
{
	//char text[1024];

	if(Nombre < 1000)ConvertirUnAMille(Nombre,string);
	if((Nombre >= 1000)&&(Nombre < 1000000))ConvertMillion(Nombre,string);
	if((Nombre >= 1000000)&&(Nombre < 1000000000))ConvertMilliard(Nombre,string);
	if((Nombre >= 1000000000)&&(Nombre < 2147483647))ConvertMilleMilliard(Nombre,string);


}

void EnleverZero(char *chiffre)
{
	int a;
	int n=strlen(chiffre)-1;

	for(a=n;a>=0;a--)
	{
		if((*(chiffre+a))=='0') (*(chiffre+a))=0; else break;
	}
	
}

void ConvertirNombreVirgule(double Nombre, char* string)
{
	int n;
	char str[1024];

	*string = 0;

	n = (int)floor(Nombre);

	ConvertMax(n,string);

	if((Nombre-n)!=0.0)
	{
		strcat(string,virgule);

		sprintf(str,"%f",Nombre-n);

		EnleverZero(str);

		ConvertMax(atoi(&(str[2])),string);
	}

}

void ConvertirNombre(int Nombre, char* string)
{
	//char text[1024];
	*string = 0;
	if(Nombre < 1000)ConvertirUnAMille(Nombre,string);
	if((Nombre >= 1000)&&(Nombre < 1000000))ConvertMillion(Nombre,string);
	if((Nombre >= 1000000)&&(Nombre < 1000000000))ConvertMilliard(Nombre,string);
	if((Nombre >= 1000000000)&&(Nombre < 2147483647))ConvertMilleMilliard(Nombre,string);


}

void PlayNumberVirgule(char *nombre,char *directory)
{
	int a;
	int len;
	int start=0;
	char text[1024];
	char file[255];


	PlaySound(NULL,NULL,SND_PURGE );

	//ConvertirNombreVirgule(Nombre,text);
	strcpy(text,nombre);
	strcat(text," ");
	len=strlen(text);
	for(a=0;a<len;a++)
	{
		if(text[a]==' ') 
		{
			text[a]=0;
			wsprintf(file,"%s\\%s.wav",directory,&(text[start]));
			PlaySound(file,NULL,SND_SYNC|SND_FILENAME|SND_NODEFAULT  );

			start = a+1;
		}


	}
	
	PlaySound(NULL,NULL,SND_PURGE );
}

// Uses the MCI_OPEN, MCI_RECORD, and MCI_SAVE commands to record and
// save a waveform-audio file. Returns 0L if successful; otherwise,
// it returns an MCI error code.
DWORD recordWAVEFile(HWND hWnd)
{
    UINT wDeviceID;
    DWORD dwReturn;
    MCI_OPEN_PARMS mciOpenParms;
    MCI_RECORD_PARMS mciRecordParms;
    MCI_SAVE_PARMS mciSaveParms;
	int a;
	char file[255];
	char buff[255];

	stop = 0;

	for(a=0;a<27;a++)
	{

		if(GetAsyncKeyState(VK_ESCAPE))break;

		if((a>=0)&&(a<=16)) strcpy(buff,unite[a]);
		if((a>=17)&&(a<=21)) strcpy(buff,dizaine[a-15]);
		if((a>=22)&&(a<=25)) strcpy(buff,GrandeUnite[a-22]);
		if(a==26) strcpy(buff,virgule);


		SetWindowText(hWnd,"3");
		UpdateWindow(hWnd);
		Sleep(500);	
		
		SetWindowText(hWnd,"2");
		UpdateWindow(hWnd);
		Sleep(500);	

		SetWindowText(hWnd,"1");
		UpdateWindow(hWnd);
		Sleep(500);	

		mciOpenParms.lpstrDeviceType = "waveaudio";
		mciOpenParms.lpstrElementName = "";
		if (dwReturn = mciSendCommand(0, MCI_OPEN,
			MCI_OPEN_ELEMENT | MCI_OPEN_TYPE,         (DWORD)(LPVOID) &mciOpenParms))    {
			return (dwReturn);
		}

		wDeviceID = mciOpenParms.wDeviceID;


		SetWindowText(hWnd,buff);
		UpdateWindow(hWnd);
		mciRecordParms.dwTo = 1000;
		if (dwReturn = mciSendCommand(wDeviceID, MCI_RECORD, 
			MCI_TO | MCI_WAIT, (DWORD)(LPVOID) &mciRecordParms))
		{
			mciSendCommand(wDeviceID, MCI_CLOSE, 0, (DWORD)NULL);
			return (dwReturn);
		}

		SetWindowText(hWnd,"");

		wsprintf(file,"%s.wav",&(buff[1]));
		mciSaveParms.lpfilename=file;
		if (dwReturn = mciSendCommand(wDeviceID, MCI_SAVE,
			MCI_SAVE_FILE | MCI_WAIT, (DWORD)(LPVOID) &mciSaveParms))
		{
			mciSendCommand(wDeviceID, MCI_CLOSE, 0, (DWORD)NULL);
			return (dwReturn);
		}	
		
		mciSendCommand(wDeviceID, MCI_CLOSE, 0, (DWORD)NULL);

	}




    return (0L);
}

void StopRecord()
{

	stop = 1;

}
 
